;////////////////////////////////////////////////////////////////////////////////////
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;                   P A G E   N 2
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;////////////////////////////////////////////////////////////////////////////////////

#define ZgCnt	.7	;     CGRAM LCD

#define _LAr	.3	;     CGRAM LCD
#define _RAr	.4	;     CGRAM LCD
#define _UAr	.5	;     CGRAM LCD
#define _DAr	.6	;     CGRAM LCD

#ifdef MBreak
  #define _LSAr	.5	;       CGRAM LCD
  #define _RSAr	.6	;       CGRAM LCD
#endif

;**********************************************************************
;  ,  
;**********************************************************************

T3_Read       	movwf	Temp1
		movlw	LOW Table3
        	addwf	Temp1, F	; 8     (  C)
		movlw	HIGH Table3	; 5   (movlw     C)
		btfsc	STATUS, C	;    0xFF ?
		addlw	.1		;      
		movwf	PCLATH
		movf	Temp1, W

Table3		movwf	PCL		;  

omega		dt	b'00000000'	; 1- 
		dt	b'00001110'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00001010'
		dt	b'00011011'
		dt	b'00000000'
		
mu		dt	b'00000000'	;	2 - mu
		dt	b'00000000'
		dt	b'00010010'
		dt	b'00010010'
		dt	b'00010010'
		dt	b'00011110'
		dt	b'00010001'
		dt	b'00010000'

LArrow		dt	b'00000000'	; 3 - Left Arrow
		dt	b'00000001'
		dt	b'00000011'
		dt	b'00000111'
		dt	b'00001111'
		dt	b'00000111'
		dt	b'00000011'
		dt	b'00000001'

RArrow	dt	b'00000000'	; 4 - Right Arrow
		dt	b'00001000'
		dt	b'00001100'
		dt	b'00001110'
		dt	b'00001111'
		dt	b'00001110'
		dt	b'00001100'
		dt	b'00001000'

UpArrow	dt	b'00000000'	; 5 - Up Arrow
		dt	b'00000100'
		dt	b'00000100'
		dt	b'00001110'
		dt	b'00001110'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00000000'



DnArrow	dt	b'00000000'	; 6 - Down Arrow
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00001110'
		dt	b'00001110'
		dt	b'00000100'
		dt	b'00000100'
		dt	b'00000000'
		
		
Up_a	dt	b'00001100'	; 7 -  
		dt	b'00010100'
		dt	b'00011100'
		dt	b'00010100'
		dt	b'00000000'
		dt	b'00000000'
		dt	b'00000000'
		dt	b'00000000'		



;**********************************************************************
;  
;**********************************************************************

#define	M1_Items	.3		;      

T4_Read       	movwf	MTemp1
		movlw	LOW Table4
		addwf	MTemp1, F	; 8     (  C)
		movlw	HIGH Table4	; 5   (movlw     C)
		btfsc	STATUS, C	;    0xFF ?
		addlw	.1		;      
		movwf	PCLATH
		movf	MTemp1, W

Table4		movwf	PCL		;  

_I1		dt	"Settings",0
_I2		dt	"Reset to def",0
_I3		dt	"Edit",0


M1_Offset
		dt	LOW (_I1-Table4)
		dt	LOW (_I2-Table4)
		dt	LOW (_I3-Table4)

MenuKey		dt	" Esc  ",_LAr,"  ",_RAr,"  Ent ",0
Help_Key	dt	"E  ",_LAr,"  ",_DAr,"  ",_UAr,"  ",_RAr,"  N",0
Need_Load	dt	"Need cal. LOAD ",0

OK			dt  " OK",0

SM_Items	dt	.8		;    1 
			dt	.2		;    2 
			dt	.3		;    3 

;  1-  
_SI11		dt	"Save auto",0
_SI12		dt	"Save now",0
_SI13		dt	"Sound on",0
_SI14		dt	"Sound off",0
_SI15		dt	"ADC 250kHz",0
_SI16		dt	"ADC 100kHz",0
_SI17		dt	"OSL on",0
_SI18		dt	"OSL off",0

;  2-  
_SI21		dt	"Open/Short",0
_SI22		dt	"Settings",0

;  3-  
_SI31		dt	"Rstd",0
_SI32		dt	"L/Cstd",0
_SI33		dt	"Coeff U bias",0

SM_Offset	dt	LOW (_SI11-Table4)
		dt	LOW (_SI12-Table4)
		dt	LOW (_SI13-Table4)
		dt	LOW (_SI14-Table4)
		dt	LOW (_SI15-Table4)
		dt	LOW (_SI16-Table4)
		dt	LOW (_SI17-Table4)
		dt	LOW (_SI18-Table4)

SM2_Offset	dt	LOW (_SI21-Table4)
		dt	LOW (_SI22-Table4)


SM3_Offset	dt	LOW (_SI31-Table4)
		dt	LOW (_SI32-Table4)
		dt	LOW (_SI33-Table4)

;**********************************************************************
;	 a -> Load CGRAM LCD
;**********************************************************************
Load_ZG
		movlw	b'01001000' 		; AC in CGRAM=8
		pagesel	CmdLCD
		call	CmdLCD
		pagesel	$
		clrf	Count1
		incf	Count1, F		;  
Loop_ZG
		movf	Count1, W		
		call	T3_Read			;    
		pagesel CharLCD
		call	CharLCD
		pagesel	$
		incf	Count1,F
		movlw	((ZgCnt<<3)+1)		;6   8  (+1->  "1")
		subwf	Count1,W
		btfss	STATUS, Z
		goto	Loop_ZG
		return

;**********************************************************************
;	   LCD   bank  page
;**********************************************************************
PrintChar
		pagesel CharLCD		; 
		call	CharLCD		;    Banksel 
		pagesel	$
		banksel	MTable		;  
		return
;**********************************************************************
;	   LCD     bank  page
;**********************************************************************
PrintCharSP
		pagesel CharLCD
		call	CharLCD
		call	DispSP		; 
		pagesel	$
		banksel	MTable		;  
		return

;**********************************************************************
;	   LCD  
;	 W=
;	 W=  
;**********************************************************************
PrintStr
		movwf	MCount1		;     
		clrf	MCount2		;     LCD
TxtLoop
		movf	MCount1,W
		call	T4_Read
		andlw	0xFF		;    
		btfsc	STATUS, Z
		goto	TxtEnd
		call	PrintChar
		incf	MCount1, F
		incf	MCount2, F
 		goto	TxtLoop
TxtEnd
		movf	MCount2, W
		return

;**********************************************************************
;	     
;	 W=
;	 W= 
;**********************************************************************
TxtLen
		movwf	MCount1		;     
		clrf	MCount2		;   
LenLoop
		movf	MCount1,W
		call	T4_Read
		andlw	0xFF		;    
		btfsc	STATUS, Z
		goto	LenEnd
		incf	MCount1, F
		incf	MCount2, F
 		goto	LenLoop
LenEnd
		movf	MCount2, W
		return

;**********************************************************************
;	 N   LCD
;	 W -  
;**********************************************************************
PrnSp
		movwf	MCount1
		movf	MCount1, W	;   Z
		btfsc	STATUS, Z	; W<>0?
		return			; =0 ->    
LoopSp
		pagesel DispSP		
		call	DispSP		;  
		pagesel	$
		banksel	MTable		;  
		decfsz	MCount1, F
		goto	LoopSp
		return		


;**********************************************************************
;	    LCD
; :
;	W      -   
;	MTable -         
;	MItem  -   
;**********************************************************************
PrintItem
#ifdef MBreak
		movwf	MCur		;    
		movf	MCur, W		;  Mpos==0   Z
		movlw	_LSAr		;    
		btfss	STATUS, Z
		movlw	_LAr		;   
		call	PrintCharSP	;       
		movf	MTable, W	;       
		addwf	MCur, W		;   
		call	T4_Read		;  
		call	PrintStr	;    
		sublw	(.16-2-1)	; 16 , 2  , 1   
		call	PrnSp		;    
		movf	MItems, W	;    
		addlw	0xFF		; W=W-1
		subwf	MCur, W		; W=Max-Current-1
		movlw	_RAr		;   	
		btfsc	STATUS, Z	;   ?
		movlw	_RSAr		;    
		call	PrintChar	;   
		return
#else
;      
		addwf	MTable, W	;       
		call	T4_Read		;  
#ifdef MCenter
		movwf	MCur
		call	TxtLen		;   
		sublw	.16		; W=16- 
		movwf	MTemp2
		bcf	STATUS, C
		rrf	MTemp2, W	; W=W/2
		movwf	MTemp2
		call	PrnSp		;   
		movf	MCur, W
#endif
		call	PrintStr	;    
#ifdef MCenter
		addwf	MTemp2, W	;    
#endif
		sublw	.16		; W = 16 -  - 
		call	PrnSp		;    
		return
#endif

;**********************************************************************
;	    
;**********************************************************************

#ifdef MBreak
MenuBeep
		banksel	INTCON		;  
		btfss	_BeepOn		;     
		goto	BeepEnd
WaitSpEnd		
		btfsc	_Beep
		goto	WaitSpEnd	;    

		bcf	INTCON, GIE	;       

		call	Wait50ms
		banksel	INTCON		;  

		bsf	_Beep		;   
		banksel	OPTION_REG
		movlw	b'10000011'	;  - .,  1:16
		movwf	OPTION_REG				
		banksel	INTCON		;  =710 => 1/(710*2)= 0.704us
		movlw	LOW BeepTime	;   0.704u*355=0.25
		movwf	CountBeep
		movlw	HIGH BeepTime
		movwf	CountBeep1
		
		bsf	INTCON, GIE	;  
BeepEnd
		banksel	MTable		;  
		return
#endif

;**********************************************************************
;	    
;**********************************************************************
CaptureBeep
		banksel	INTCON		;  
		btfss	_BeepOn		;     
		goto	CaptEnd
BpEnd		
		btfsc	_Beep
		goto	BpEnd		;    

		bcf	INTCON, GIE	;     

		bsf	_Beep		;   
		banksel	OPTION_REG
		movlw	b'10000011'	;  - .,  1:16
		movwf	OPTION_REG				
		banksel	INTCON		;  =710 => 1/(710*2)= 0.704us
		movlw	CaptTime	;   0.704u*71=0.05
		movwf	CountBeep
		
		bsf	INTCON, GIE	;  
CaptEnd
		banksel	INTCON		;  
		return

;**********************************************************************
;	  50      
;**********************************************************************
Wait50ms
		banksel	INTCON
		pagesel	Delay_50_ms
		call	Delay_50_ms		
		pagesel	$
		banksel	MTable
		return

;**********************************************************************
;	  
;**********************************************************************
MenuInit	
		banksel	Mpos
		clrf	Mpos
Menu1Loop
		pagesel	SecLine
		call	SecLine		;   
		pagesel	$
		banksel	Mpos
		movlw	LOW (MenuKey-Table4)
		call	PrintStr	;   
	
		movlw	M1_Items	;     
		movwf	MItems		; 
		movlw	LOW (M1_Offset-Table4) ;    
		movwf	MTable		; 
DispItem
		pagesel	CursorHome
		call	CursorHome	;  
		pagesel	$
		banksel	Mpos
		movf	Mpos, W		;   
		call	PrintItem	;     LCD
KBD_Loop
		call	Wait50ms
		movlw	Kn_ALL_UP
		subwf	Btn_status, W
		btfsc	STATUS, Z
		goto	NotKey			;   
;--------------------------------------------------------------------------
#ifdef MBreak		;      
;--------------------------------------------------------------------------
		btfsc	Btn_status, Btn_S3	; S3 - 
		goto	RightKey
		movlw	Kn_ALL_UP
		movwf	Btn_status
		movlw	0xFF
		addwf	Mpos, F			; Mpos=Mpos-1   
		btfsc	STATUS, C		;   
		goto	DispItem
		incf	Mpos, F			; Mpos<0   
		call	MenuBeep		
		goto	NotKey
;--------------------------------------------------------------------------
RightKey	btfsc	Btn_status, Btn_S4	; S4 - 
		goto	ESCKey
		movlw	Kn_ALL_UP
		movwf	Btn_status
		incf	Mpos, F			;   
		movlw	M1_Items		;    
		subwf	Mpos, W			; W=Max-Current
		btfss	STATUS, C		;   
		goto	DispItem
		decf	Mpos, F
		call	MenuBeep		
		goto	NotKey
;--------------------------------------------------------------------------
#else			;  
;--------------------------------------------------------------------------
		btfsc	Btn_status, Btn_S3	; S3 - 
		goto	RightKey
		movlw	Kn_ALL_UP
		movwf	Btn_status
		movlw	M1_Items		;    
		movf	Mpos, F
		btfsc	STATUS, Z
		movwf	Mpos
		decf	Mpos, F			; Mpos=Mpos-1   
		goto	DispItem		
;--------------------------------------------------------------------------
RightKey	btfsc	Btn_status, Btn_S4	; S4 - 
		goto	ESCKey
		movlw	Kn_ALL_UP
		movwf	Btn_status
		incf	Mpos, F			;   
		movlw	M1_Items		;    
		subwf	Mpos, W			; W=Max-Current
		btfsc	STATUS, Z		;   
		clrf	Mpos			;  ->   
		goto	DispItem
;--------------------------------------------------------------------------
#endif
;--------------------------------------------------------------------------
ESCKey		btfsc	Btn_status, Btn_S2	; S2 - ESC
		goto	EnterKey
		banksel	INTCON
		pagesel	Kn_end
		goto	Kn_end
		
;--------------------------------------------------------------------------
EnterKey	btfsc	Btn_status, Btn_S5	; S5 - Enter
		goto	NotKey
		movlw	Kn_ALL_UP
		movwf	Btn_status
		pagesel	CursorHome
		call	CursorHome	;  
		pagesel	$
		banksel	Mpos
		movlw	LOW (M1_Offset-Table4) ;    
		addwf	Mpos, W		;   
		call	T4_Read		;  
		call	PrintStr	;  1-   
		sublw	.16		; 16  LCD
		call	PrnSp		;    
		goto	SMenu		;     
;--------------------------------------------------------------------------
NotKey	
		movlw	Kn_ALL_UP
		movwf	Btn_status
		goto	KBD_Loop	

;**********************************************************************
;	   
;**********************************************************************

SMenu
		clrf	SMpos

		pagesel	SecLine
		call	SecLine		;   
		pagesel	$
		banksel	Mpos
		movf	Mpos, W		;    1- 
		movwf	MCount1
		movlw	LOW (SM_Items-Table4)	;      
		movwf	MCount2
		bcf	STATUS, C
		clrf	SElements		;      
SM_ItemLoop		
		movf	MCount1, W
		btfsc	STATUS, Z	;    
		goto	EndItem		; To   
		movf	MCount2, W	;       
		call	T4_Read		;       
		addwf	SElements, F	;      
		incf	MCount2, F
		decf	MCount1, F
		goto	SM_ItemLoop
EndItem
		movlw	LOW (SM_Offset-Table4) ;    	
		addwf	SElements, W	;      
		movwf	MTable		;    .  
		movlw	LOW (SM_Items-Table4)	;      
		addwf	Mpos, W		;      		
		call	T4_Read		;    .   
		movwf	MItems		; 
Disp2Item
		pagesel	SecLine
		call	SecLine		;   
		pagesel	$
		banksel	SMpos

		movf	SMpos, W
		call	PrintItem	;     LCD
		call	Print_Set_Item
		banksel SMpos
			
KBD2_Loop
		call	Wait50ms
		movlw	Kn_ALL_UP
		subwf	Btn_status, W
		btfsc	STATUS, Z
		goto	Not2Key			;   
;--------------------------------------------------------------------------
#ifdef MBreak		;      
;--------------------------------------------------------------------------
		btfsc	Btn_status, Btn_S3	; S3 - 
		goto	Right2Key
		movlw	Kn_ALL_UP
		movwf	Btn_status
		movlw	0xFF
		addwf	SMpos, F		; SMpos=SMpos-1   
		btfsc	STATUS, C		;   
		goto	Disp2Item
		incf	SMpos, F		; Mpos<0   
		call	MenuBeep		
		goto	Not2Key

;--------------------------------------------------------------------------
Right2Key	btfsc	Btn_status, Btn_S4	; S4 - 
		goto	ESC2Key
		movlw	Kn_ALL_UP
		movwf	Btn_status
		incf	SMpos, F		;   
		movf	MItems, W		;    
		subwf	SMpos, W		; W=Max-Current
		btfss	STATUS, C		;   
		goto	Disp2Item
		decf	SMpos, F
		call	MenuBeep		
		goto	Not2Key
;--------------------------------------------------------------------------
#else			;  
;--------------------------------------------------------------------------
		btfsc	Btn_status, Btn_S3	; S3 - 
		goto	Right2Key
		movlw	Kn_ALL_UP
		movwf	Btn_status
		movf	MItems, W	;    
		movf	SMpos, F
		btfsc	STATUS, Z
		movwf	SMpos
		decf	SMpos, F	; SMpos=SMpos-1   
		goto	Disp2Item		
;--------------------------------------------------------------------------
Right2Key	btfsc	Btn_status, Btn_S4	; S4 - 
		goto	ESC2Key
		movlw	Kn_ALL_UP
		movwf	Btn_status
		incf	SMpos, F		;   
		movf	MItems, W		;   
		subwf	SMpos, W		; W=Max-Current
		btfsc	STATUS, Z		;   ?
		clrf	SMpos			;  ->   
		goto	Disp2Item
;--------------------------------------------------------------------------
#endif
;--------------------------------------------------------------------------

ESC2Key		btfsc	Btn_status, Btn_S2	; S2 - ESC
		goto	Enter2Key
		movlw	Kn_ALL_UP
		movwf	Btn_status	
		goto	Menu1Loop		;    1- 		
;--------------------------------------------------------------------------
Enter2Key	btfsc	Btn_status, Btn_S5	; S5 - Enter
		goto	Not2Key
		movlw	Kn_ALL_UP
		movwf	Btn_status
		movf	SElements, W		;  1-    
		addwf	SMpos, W		;   
		addlw	0x01
		goto	SMenuExecute
;--------------------------------------------------------------------------
Not2Key	
		movlw	Kn_ALL_UP
		movwf	Btn_status
		goto	KBD2_Loop

;--------------------------------------------------------------------------
;  *   
Print_Set_Item
		movf	SElements, W		;  1-    
		addwf	SMpos, W		;   
		addlw	0x01
		movwf	MTemp1
		movlw	LOW item_sel
		addwf	MTemp1, F	; 8     (  C)
		movlw	HIGH item_sel	; 5   (movlw     C)
		btfsc	STATUS, C	;    0xFF ?
		addlw	.1		;      
		movwf	PCLATH
		movf	MTemp1, W
		banksel	INTCON
item_sel		
		movwf	PCL		;  
		goto	p_item_11	; 	1    1- 
		goto	p_item_12	;	2
		goto	p_item_13	;	3
		goto	p_item_14	;	4
		goto	p_item_15	;	5
		goto	p_item_16	;	6
		goto	p_item_17	;	7
		goto	p_item_18	;	8

		return		; 	1    2- 
		return		;	2

		return		; 	1    3- 
		return		;	2
		return		;	3
;------------------------
p_item_11
		btfss	Flags1, Auto_Save
		return
		goto	print_star

p_item_12	
		btfsc	Flags1, Auto_Save
		return
		goto	print_star

p_item_13
		btfss	_BeepOn
		return
		goto	print_star

p_item_14
		btfsc	_BeepOn
		return
		goto	print_star

p_item_15
		btfsc	Flags3, ADC_100kHz
		return
		goto	print_star

p_item_16
		btfss	Flags3, ADC_100kHz
		return
		goto	print_star

p_item_17
		btfsc	Flags3, OSL_Off	;1 - OSL 
		return
		goto	print_star

p_item_18
		btfss	Flags3, OSL_Off	;1 - OSL 
		return
		goto	print_star

print_star
		banksel	MTemp2	;   
		movlw	0xC0-1
		addwf	MTemp2, W
		banksel	0
		pagesel CharLCD
		call	CmdLCD
		movlw	"*"	
		call	CharLCD
		pagesel	$
		banksel	MTable		;  
		return

;--------------------------------------------------------------------------
SMenuExecute
		movwf	MTemp1
		movlw	LOW MenuRun
		addwf	MTemp1, F	; 8     (  C)
		movlw	HIGH MenuRun	; 5   (movlw     C)
		btfsc	STATUS, C	;    0xFF ?
		addlw	.1		;      
		movwf	PCLATH
		movf	MTemp1, W
		banksel	INTCON
MenuRun		
		movwf	PCL		;  
		goto	SRun11	;    1- 
		goto	SRun12
		goto	SRun13
		goto	SRun14
		goto	SRun15
		goto	SRun16
		goto	SRun17
		goto	SRun18

		goto	SRun21	;    2- 
		goto	SRun22

		goto	Rstd_edit	;    3- 
		goto	Xstd_edit
		goto	Ubias_edit
;--------------------------------------------------------------------------
SRun11	
		bsf	Flags1, Auto_Save
		call	EE_Save_set_force
		goto	m_exit

SRun12	
		bcf	Flags1, Auto_Save
		call	EE_Save_set_force
		goto	m_exit

SRun13	
		bsf	_BeepOn
		call	EE_Save_set
		goto	m_exit

SRun14	
		bcf	_BeepOn
		call	EE_Save_set
		goto	m_exit

SRun15	
		bcf			Flags3, ADC_100kHz
SRun15_1		
		pagesel		Set_Freq
		call		Set_Freq
		pagesel		$
		call		EE_Save_set
		goto		m_exit

SRun16	
		bsf			Flags3, ADC_100kHz
		goto		SRun15_1

SRun17	
		bcf		Flags3, OSL_Off
		call	EE_Save_set
		goto	m_exit

SRun18	
		bsf		Flags3, OSL_Off
		call	EE_Save_set
		goto	m_exit

SRun21	
		call	Reset_Open_Short
		goto	m_exit

SRun22	
		call	Reset_Settings
		goto	m_exit


;--------------------------------------------------------------------------
;         + OK
m_exit		
		pagesel	SecLine
		call	SecLine		;   
		pagesel	$
		banksel	Mpos
		movf	SMpos, W		
		addwf	MTable, W	;       
		call	T4_Read		;  
		call	PrintStr	;    
		movwf	MCur	;   
		movlw	LOW (OK-Table4);  
		call	PrintStr
		addwf	MCur, W	;    
		sublw	.16
		call	PrnSp
		banksel	INTCON
		pagesel	Kn_end
		call	Delay_05_sec
		call	Delay_05_sec
		call	Delay_05_sec
		pagesel	$
		goto	Menu1Loop		;    1- 		

;===================================================
;     
;---------------------------------------------------
;   Open_Short 
; Zs...Yo... - 24+24=48
Reset_Open_Short
		pagesel		ClrA
		call		ClrA
		movlw		LOW Zs ;      EEPROOM
		movwf		Temp1
res_loop1
		movf		Temp1, W
		pagesel		A_To_EEPROM
		call		A_To_EEPROM
		pagesel		$
		movlw		4
		addwf		Temp1, F
		movf		Temp1, W
		sublw		Low Zs + .48
		btfss		STATUS, Z
		goto		res_loop1
		return

;---------------------------------------------------
;      
Reset_Settings
		movlw	1<<Auto_Range | 1<<Beeper_On
		movwf	Flags1
		movlw	1
		movwf	Freq	; 1
		clrf	Flags3
		call	EE_Save_set_force
		goto	to_set_freq
		
;------------------------------------------------------------
;      EEPROM
;------------------------------------------------------------
EE_Restore_set
		movlw		LOW EE_Flags1
		pagesel		EEPROM_To_A
		call		EEPROM_To_A	;  4    
		movf		AEXP, W	; Flags1
		iorlw		1<<Auto_Range	;    
		andlw		~(1<<hold)	;  
		movwf		Flags1
		movf		AARGB0, W
		movwf		Freq
		movf		AARGB1, W
		movwf		Flags3
to_set_freq
		pagesel		Set_Freq
		call		Set_Freq
		pagesel		$
		return

;------------------------------------------------------------
;      EEPROM
;------------------------------------------------------------
EE_Save_set
		btfss		Flags1, Auto_Save
		return
EE_Save_set_force
		movlw		LOW EE_Flags1
		movwf		EE_ADR
		movf		Flags1, W
		movwf		EE_DATA
		pagesel		WriteEEPROM
		call		WriteEEPROM

		banksel		EE_ADR
		incf		EE_ADR, F	;Freq
		movf		Freq, W
		movwf		EE_DATA
		call		WriteEEPROM

		banksel		EE_ADR
		incf		EE_ADR, F	;Flags3
		movf		Flags3, W
		movwf		EE_DATA
		call		WriteEEPROM
		banksel		EE_ADR

		pagesel		$
		return


