;
;	 RLC2
;                
;	:	  ()
;			  ()
;
;		1.3
;	 	12/12/2009
;

;	    PIC16F876A
;***************************************************************************************
;* *             *   
;***************************************************************************************

; 1    *  MCLR/Vpp         * 
; 2    *  RA0/AN0          * U - (analog in)
; 3    *  RA1/AN1          *  U/I	(out) 0- U, 1- I
; 4    *  RA2/AN2/Vref-    * Mul10	(out) 0- =10,	1- =1
; 5    *  RA3/AN3/Vref+    * Mul100	(out) 0- =10,	1- =1
; 6    *  RA4/T0CKI        * F_1	(out) 1-   1
; 7    *  RA5/AN4/SS       * F_2	(out) 1-   100
; 8    *  Vss              * GND
; 9    *  OSC1/CLKIN       *  16 
; 10   *  OSC2/CLKOUT      *  16 
; 11   *  RC0/T1OSO/T1CKI  * AdcClk 100/250kHz	(in)
; 12   *  RC1/T1OSI/CCP2   * Busy	(in)
; 13   *  RC2/CCP1         * SinClk	(out)
; 14   *  RC3/SCK/SCL      * Pol	(in)

; 15   *  RC4/SDI/SDA      * ClkSel	(out) 0- 0_Clk,	1- 90_Clk
; 16   *  RC5/SDO          * 
; 17   *  RC6/TX/CK        * AdcClk 100/250kHz	(in)
; 18   *  RC7/RX/DT        *
; 19   *  Vss              * +5V
; 20   *  Vdd              * GND
; 21   *  RB0/INT          *
; 22   *  RB1              * RanA	(out)
; 23   *  RB2              * RanB	(out)
; 24   *  RB3/PGM          * Beep	(out)
; 25   *  RB4              * LCD/KBD clock	(out)
; 26   *  RB5              * LCD/KBD data	(in/out)
; 27   *  RB6/PGC          * PGC
; 28   *  RB7/PGD          * PGD

;****************************************************************************************
;   
;****************************************************************************************
#define TL082 1		;      TL082
;#define PGA103 1	;     PGA103

;****************************************************************************************
;    
;****************************************************************************************
#define OSC16 1		;   16
;#define OSC20 1	;   20	

;****************************************************************************************
;    ("" / "    ")
;****************************************************************************************
;#define MBreak 1	;    (   )

;****************************************************************************************
;     
;****************************************************************************************
#define MCenter 1	;   LCD (     1-  LCD)
	

Port_A_Config		equ	b'11000001'
; Port A bit equates
U_I			equ	1
Mul10			equ	2
Mul100			equ	3
F_1			equ	4
F_2			equ	5

Port_B_Config		equ	b'11000000'

; Port B bit equates
Btn_S1			equ	0
Btn_S2			equ	1
Btn_S3			equ	2
Btn_S4			equ	3
Btn_S5			equ	4
Btn_S6			equ	5

RanA			equ	1
RanB			equ	2

Kn_ALL_UP		equ	b'00111111'

Port_C_Config		equ 	b'11001011'

; Port C bit equates
Busy			equ	1
Pol			equ	3
ClkSel			equ	4

;****************************************************************************************


	list      p=PIC16F876a
	#include  P16F876a.inc 			; 16.000 MHz (20.000 MHz)
	errorlevel  -302, -306             	; suppress message 302 and 306 from list file

	__CONFIG _CP_OFF & _BODEN_ON & _HS_OSC & _WRT_OFF & _WDT_OFF & _PWRTE_ON & _DEBUG_OFF & _CPD_OFF & _LVP_OFF

; Settings for LCD and KBD procedures

#define PortLCD		PORTB
#define TrisLCD		TRISB
#define _LCDTris 	TrisLCD,4	; Tris Register for Keyboard Data
#define _LCDData	PortLCD,4	; Data pin shift register and Input Data from Keyboard
#define _LCDClock	PortLCD,5	; Clock pin Shift register


; Settings for Speaker procedure
#define PortSPK		PORTB		; Port used for Speaker
#define SPK		3		; Bit used for the speaker (RB3)
#define MaskSPK		(H'01'<< SPK & H'FF')

;    = 710Hz   710*2=1420Hz
;*********************************************************************
#ifdef OSC16	;  16Hz
  ; 16mHz/4/16/(256-80)=1420Hz			
  #define BeepFRQ	.80	 ;  Timer0     
  ;   Timer0       16.384 ms
  ; 16Hz/4/256/256=61,035Hz  1/61,035=16.384 ms
  ;  Timer0   " " (1/16.384ms=61)
  #define LongBTN	.61   
#endif

;*********************************************************************
#ifdef OSC20	;  20Hz
  ; 20MHz/4/16/(256-36)=1420Hz			
  #define BeepFRQ	.36	 ;  Timer0    
  ;  Timer0       13.107 ms
  ;20Hz/4/256/256=76,294Hz  1/76,294=13.107 ms
  ;  Timer0   " " (1/13.107ms=76)
  #define LongBTN	.76
#endif
;*********************************************************************
;    0.25s => 0.25s*1420Hz = 355
#define BeepTime	.150
;    0.05s => 0.05s*1420Hz = 71
#define CaptTime	.20
;*********************************************************************

; USART    AdcClc 250  100  RC6
;F=Fosc/(4*(N+1)) => N=(Fosc/4/F)-1
#ifdef OSC16	;  16Hz
  #define Clc250k	.15	 ;16MHz/4/250kHz-1=15
  #define Clc100k	.39	 ;16MHz/4/100kHz-1=39
#endif

#ifdef OSC20	;  20Hz
  #define Clc250k	.19	 ;20MHz/4/250kHz-1=19
  #define Clc100k	.49	 ;20MHz/4/100kHz-1=49
#endif 

;  Flags
go_ADC		equ 	0	;    
long_btn	equ 	1	; ""  
disp_UI		equ	5	;       !!! -   
debug		equ	6	; 
L_Z		equ	7	;    

#define _LCDCmd		Flags, 2	;  ,   LCD
#define _LCDBusy	Flags, 3	;   LCD  
#define _Beep		Flags, 4	;    
#define _BeepOn		Flags1,1	;    
#define	_Long_Btn1	db_flags,6	;  ""  

;  Flags1
Auto_Range	equ 	0	;   
Beeper_On	equ     1	;      
S_P			equ	2	; - 0,  - 1  
LC_X		equ	3	;    0-LC, 1-X
Auto_Save	equ	4	;1 -     
RQD1		equ	5	;    00-R, 01-Q, 10-D
RQD2		equ	6
hold		equ	7	; 

;  Flags2
cal_mode	equ 	0	;1 -  OPEN/SHORT 
cal_start	equ 	1	;   ( Zs  Yo)
C_change	equ 	2	;- ,    EEPROM
U_no_disp1	equ 	3	;   U bias
U_no_disp2	equ 	4	;   
LOAD_cal_mode	equ	5	; LOAD 
LOAD_cal_start	equ	6	; LOAD 
				;     .
ADC_ovl		equ	7	; 

;  Flags3
fixed_C		equ 	0	;   
fixed_L		equ 	1	;   
Capt_L		equ		2	;      
Capt_H		equ		3
ADC_100kHz	equ		4	;  100   
OSL_Off		equ		5	; OSL 

; 	db_flags
;   ! 
db_Mul10	equ 	0
db_Mul100	equ 	1
db_RanA		equ 	2
db_RanB		equ 	3
db_Re		equ 	4
db_Im		equ 	5
Long_Btn1	equ 	6	; ""  
L_C			equ		7	;  0-L, 1-C

	CBLOCK 0x35 ;0x20-0x34 for FLOATING POINT LIBRARY
	;	 
	Flags

	Dly0  ;Stores 3 bytes of data for the delay count
	Dly1  ;Dly0 is the least significant byte
	Dly2  ;while Dly2 is the most significant byte
;-------------	
	BCD0	;  
	BCD1
	BCD2
	BCD3
	BCD4	;  
	T0
	T1
;-------------	

	PORTA_copy	;    , .. RA4   , 
				;    0 (RA4    -),
				;      bcf, bsf
	Freq	; 0-100, 1-1000, 2-10
	Range	;  1...8
	ADC_L
	ADC_H

	Temp_LCD	;     
	Count_LCD	;     

	Count1
	Count2	
	NZ	;       
	
	Temp1
	Temp2
	Temp3
	f_tmp
	;--------------------------
	; 
	Z_Re3:0	;   U  Z
	U_Re3	;,  ,  
	Z_Re2:0
	U_Re2
	Z_Re1:0
	U_Re1
	Z_Re0:0
	U_Re0	;,  ,  

	Z_Im3:0
	U_Im3	;,  ,  
	Z_Im2:0
	U_Im2
	Z_Im1:0
	U_Im1
	Z_Im0:0
	U_Im0	;,  ,  
	
	I_Re3	;,  ,  
	I_Re2
	I_Re1
	I_Re0	;,  ,  
	I_Im3	;,  ,  
	I_Im2
	I_Im1
	I_Im0	;,  ,  

;	Z_Re3	;,  ,  
;	Z_Re2
;	Z_Re1
;	Z_Re0	;,  ,  
;	Z_Im3	;,  ,  
;	Z_Im2
;	Z_Im1
;	Z_Im0	;,  ,  
	;--------------------------
	;    - 
	X3
	X2
	X1
	X0
	Y3
	Y2
	Y1
	Y0
	;--------------------------
	EE_ADR	;     EEPROM
	EE_DATA
	M_Parm	;     
	ENDC

	CBLOCK 0x70
	DbgTemp		; Memory used for debuger ICD2 
			; if debuger selected in "File registers" reserved map see as "RR"
	ENDC
	
	CBLOCK 0x71
	;    (   )
	W_TEMP
	STATUS_TEMP
	PCLATH_TEMP
	;-----------
	Btn_old
	Btn_now
	Btn_status
	Btn_time
	;-----------
	m_count	;   
	db_flags
	;-----------
	CountBeep	;    
	;-----------
	Flags1
	Flags2
	Flags3
	;-----------
	Low_Lim	;     
			;   -  
			;   -    
	ENDC

	CBLOCK 0xA0	;  1
	;     
	;10    ,  80 .
	ADC_U_Re:	2*.10	;  
	ADC_U_Im:	2*.10	;  
	ADC_I_Re:	2*.10	;  
	ADC_I_Im:	2*.10	;  
	ENDC

	CBLOCK 0xF0
	DbgTemp1	; Memory used for debuger ICD2
	ENDC	
	CBLOCK 0x170
	DbgTemp2	; Memory used for debuger ICD2
	ENDC	
	CBLOCK 0x1E5
	DbgTemp3:.11	; Memory used for debuger ICD2
	ENDC	
	CBLOCK 0x1F0
	DbgTemp4	; Memory used for debuger ICD2
	ENDC	

	CBLOCK 0x110
	_Flags1	;      
	_Freq	;  
	Mpos
	MCur
	SMpos
	MTable
	MItems
	SElements
	MTemp1
	MTemp2
	MCount1
	MCount2
;------------------    .
	AkkARe:4	;   
	AkkAIm:4
	AkkBRe:4	;   
	AkkBIm:4

	TempRe:4	;  
	TempIm:4
	TempC:4
	C1Re:4
	C1Im:4
	C2Re:4
	C2Im:4
	ENDC	
	
	
;=========================
;       
;=========================

Dly24 MACRO DLY
;Take the delay value argument from the macro, precalculate
;the required 3 RAM values and load the The RAM values Dly2,Dly1 
;and Dly0.
	banksel Dly0
	movlw   DLY & H'FF'
	movwf   Dly0
	movlw   DLY >>D'08' & H'FF'
	movwf   Dly1
	movlw   DLY >>D'16' & H'FF'
	movwf   Dly2
;Bytes are shifted and anded by the assembler to make user 
;calculations easier.
	endm
	
;===========================================
		ORG		0x2100   	;  EEPROM
;-  
K_0		de	0x7F, 0x00, 0x00, 0x00	; 1
K_1		de	0x82, 0x20, 0x00, 0x00	; 10
K_2		de	0x85, 0x48, 0x00, 0x00	; 100
K_3		de	0x88, 0x7A, 0x00, 0x00	; 1 000
K_4		de	0x8C, 0x1C, 0x40, 0x00	; 10 000
K_5		de	0x8F, 0x43, 0x50, 0x00	; 100 000
K_6		de	0x92, 0x74, 0x24, 0x00	; 1 000 000
K_7		de	0x96, 0x18, 0x96, 0x80	; 10 000 000

K_bias	de	0x70, 0x79, 0xDB, 0x22	; (10*12.2*5)/(1024*10000)=0.000 059 570 312 5
E1		dt	0x82, 0x20, 0x00, 0x00	; 1E1 -> 10.0

; Zin  Open/Short 
; 2 - Re Im, 3 - 100, 1, 10, 4 ,  2*3*4=24
Zs		fill 0, .24
Zo		fill 0, .24

;----------------------------------------------------------------
;   LOAD 
;  - ,  -   _pref  tables.inc  1 ;
; 02 - 
; 03 - 
; 04 - 
; 06 - uH
; 08 - pF
;   -   
Xstd_C		equ		6
Xstd_L		equ		7

Zsdt_0		de	0x04, 0x00, 0x27, 0x10	;  1 0000 - 1 
			de	0x86, 0x00, 0x00, 0x32	;  0 0050 - 0.005 uH
Zsdt_1		de	0x04, 0x01, 0x86, 0xA0	; 10 0000 - 10 
			de	0x86, 0x00, 0x00, 0x32	;  0 0050 - 0.005 uH
Zsdt_2		de	0x04, 0x1E, 0x84, 0x80	;200 0000 - 200 
			de	0x86, 0x00, 0x00, 0x32	;  0 0050 - 0.005 uH
Zsdt_3		de	0x03, 0x00, 0x4E, 0x20	;  2 0000 - 2 
			de	0x48, 0x00, 0x03, 0x20	;  0 0800 - 0.08 
Zsdt_4		de	0x03, 0x03, 0x0D, 0x40	; 20 0000 - 20 
			de	0x48, 0x00, 0x03, 0x20	;  0 0800 - 0.08 
Zsdt_5		de	0x03, 0x1E, 0x84, 0x80	;200 0000 - 200 
			de	0x48, 0x00, 0x03, 0x20	;  0 0800 - 0.08 
Zsdt_6		de	0x02, 0x00, 0x4E, 0x20	;  2 0000 - 2 
			de	0x48, 0x00, 0x03, 0x20	;  0 0800 - 0.08 
Zsdt_7		de	0x02, 0x01, 0x86, 0xA0	; 10 0000 - 10 
			de	0x48, 0x00, 0x03, 0x20	;  0 0800 - 0.08 

; -    
Coeff_Ubias	de 0x00, 0x00, 0x27, 0x10	; 10000   

;     
EE_Flags1	de	1<<Auto_Range | 1<<Beeper_On	; Flags1
EE_Freq		de	1	; 1kHz
EE_Flags3	de	0
EE_LOAD		de	0	; =1 -  LOAD    
	
		org 	0x00 
;*******************************************************************************
;                              
;******************************************************************************* 	
		nop			;for MPLAB-ICD2
		goto		init
;===============================================
;------------------ Interrupt ------------------
;===============================================
		org		0x004
		movwf   W_TEMP		; save W
		swapf   STATUS,W	; swap STATUS, W
		clrf	STATUS		;  0
		movwf   STATUS_TEMP	; save status
		movf	PCLATH,W
		movwf	PCLATH_TEMP	; save PCLFTH
		
		pagesel	$
		btfss	INTCON, T0IF	;    TMR0
		goto	CCP2_check
		bcf	INTCON, T0IF	;   
		
		btfss	_Beep		; Beeper work?
		goto	ChkKBD		; No go chek keyboard

;     ~700  
		movlw	MaskSPK		; Get mask
		xorwf	PortSPK, F	;   
		
		movlw	BeepFRQ		;      700 
		movwf	TMR0		;    
		
		decfsz	CountBeep, F
		goto	restore_context	;  ,   
		bcf		PortSPK, SPK	; =0 ->  

		banksel	OPTION_REG	;   Timer0
		movlw	b'10000111'	;  - .,  1:256
		movwf	OPTION_REG
		banksel	INTCON
		bcf		_Beep		;   
;  
ChkKBD:
		btfsc	_LCDBusy	;  ,     LCD
		goto	restore_context

		call	GetKey		;    -> w = Btn_now

		xorlw	Kn_ALL_UP
		btfsc	STATUS, Z
		goto	btn_up		; now = 0   ,    

		movf	Btn_now, W
		subwf	Btn_old, W	; W = Btn_old - Btn_now
		btfss	STATUS, Z	 
		goto	Chk_Beep	; Old <> Now ->    

; (Old = Now) <> 0 ->     ->  " "
		decfsz	Btn_time, F	;     (~1)
		goto	restore_context	;       

		btfsc	Flags, long_btn ;    "" 
		goto	SetDblLong	;   "" 
		btfsc	_Long_Btn1	;    "" 
		goto	SetDblLong	;  
;    "" 
		bsf	Flags, long_btn	;   "" 
		goto	Chk_Beep
SetDblLong
		bcf	Flags, long_btn	;   "" 		
		bsf	_Long_Btn1	;    "" 
;    
Chk_Beep
		btfss	_BeepOn		;    
		goto	Btn_Set

		bsf		_Beep		;   
		banksel	OPTION_REG
		movlw	b'10000011'	;  - .,  1:16
		movwf	OPTION_REG				
		banksel	INTCON		;  =710 => 1/(710*2)= 0.704us
		movlw	BeepTime	;   0.704u*355=0.25
		movwf	CountBeep
		goto	Btn_Set
btn_up
;    ,      
		movf	Btn_now, W
		subwf	Btn_old, W	; W = Btn_old - Btn_now
		btfsc	STATUS, Z
		goto	restore_context ; Old = Now = "0" -   
; Old <>0, Now = 0
		movf	Btn_old, W	;    
		movwf	Btn_status	;      
Btn_Set
		movf	Btn_now, W	;   
		movwf	Btn_old		;  : Btn_old = Btn_now

		movlw	LongBTN		;   
		movwf	Btn_time	; ""  (~1ek)

		goto	restore_context

;------------------------------		

CCP2_check
		btfss   PIR2,CCP2IF	;   2
		goto	restore_context
		bcf     PIR2,CCP2IF	;clear interrupt flag		
		btfss	Flags, go_ADC
		goto	restore_context
		btfss	CCP2CON, 0	;0-    , 1-  
		goto	back
		movf	CCPR2L, W	;      
		movwf	ADC_L		;  
		movf	CCPR2H, W
		movwf	ADC_H		;  
		clrf	CCP2CON
		movlw	b'00000100'	;     
		movwf	CCP2CON
		goto	restore_context

back	;      
		movf	ADC_L, W
		subwf	CCPR2L, F	;    
		btfss	STATUS, C
		decf	CCPR2H, F
		movlw	LOW .10001	;  10001
		subwf	CCPR2L, W
		btfss	STATUS, C
		decf	CCPR2H, F
		movwf	ADC_L
		;  
		movf	ADC_H, W
		subwf	CCPR2H, F
		movlw	HIGH .10001	;  10001
		subwf	CCPR2H, W
		movwf	ADC_H
		;   
		btfss	PORTC, Pol	;: 1-, 0-
		bsf	ADC_H,7		; .  
		movlw	0x80		
		btfsc	PORTA_copy, U_I	;   , 
		xorwf	ADC_H, F	;  , .    
		;     
		clrf	CCP2CON
		movlw	b'00000101'	;     
		movwf	CCP2CON
		bcf	Flags, go_ADC	;  

restore_context
		clrf	STATUS		; 0
		
		movf	PCLATH_TEMP,W
		movwf	PCLATH
		swapf	STATUS_TEMP,W	;fetch status, reswap nibbles
		movwf   STATUS		;restore status
		swapf   W_TEMP,F    	;swap nibbles in preparation
		swapf   W_TEMP,W    	;for the swap restoration of w
		retfie			;return from interrupt
;------------------ END Interrupt ------------------


;************************************************************************************
; Initialise microcontroller
;************************************************************************************
init
		banksel		INTCON
		clrf		INTCON
		clrf		PCLATH
		clrf		PORTA
		clrf		PORTB
		clrf		PORTC
		clrf		PORTA_copy
;		clrf		Freq
		clrf		Flags
		clrf		Flags2
		call		Clr_ADC	;  
		movlw		5
		movwf		Range	;   
		movlw		1<<db_Re
		movwf		db_flags
		movlw		Kn_ALL_UP
		movwf		Btn_old
		movwf		Btn_status
		movlw		LongBTN
		movwf		Btn_time

		movlw 		HIGH Table	;     
		movwf 		PCLATH
		
		; 
		banksel		ADCON1
		movlw		b'10001110'	;  , Vdd=Vref+, Vss=Vref-, AN0
		movwf		ADCON1	; :  A0 - ,  - 
		movlw		Port_A_Config
		movwf		TRISA
		banksel		ADCON0
		movlw		b'10000001' ;Fosc/32,  AN0,   .
		movwf		ADCON0
		
		banksel		TRISB
		movlw		Port_B_Config
		movwf		TRISB
		movlw		Port_C_Config
		movwf		TRISC


		; TMR0   
		movlw		b'10000111'	; - .,  1:256
		movwf		OPTION_REG
		
		; TMR1    250   RC0
		banksel		T1CON
		movlw		b'00000011'	;.=1:1, ., RC0
		movwf		T1CON
		
		;  2    TMR1    RC1
		clrf		CCP2CON		;  CCP2
		movlw		b'00000101'	;    
		movwf		CCP2CON		;  2
		
		; USART    250  RC6
		banksel		SPBRG
		movlw		Clc250k		;F=Fosc/(4*(N+1)
		movwf		SPBRG

		movlw		b'10110000'
		movwf		TXSTA
		banksel		RCSTA
		movlw		b'10010000'
		movwf		RCSTA
;**********************************
		call		InitLCD
;**********************************
		pagesel		EE_Restore_set
		call		EE_Restore_set ;    
		pagesel		$

		; 
		banksel		PIE2
		movlw		b'00000001' 	;    CCP2
		movwf		PIE2
		banksel		INTCON
		movlw		b'11100000'	;      TMR0
		movwf		INTCON

		movlw		LOW _Hello
		call		Read_String
		call		Delay_05_sec

;========================================================
;  
;========================================================
Kn_work
		banksel		PORTA_copy
		; -   (0...9)
		incf		m_count, F
		movlw		.10
		subwf		m_count, W
		btfsc		STATUS, Z
		clrf		m_count

Kn_work_1
		movlw		Kn_ALL_UP
		subwf		Btn_status, W
		btfsc		STATUS, Z
		goto		Kn_end			;   

		btfss		_Long_Btn1		;   ""  
		goto		LongChk
;*****************************************
;-----    -----
;*****************************************
		bcf		_Long_Btn1		;   "" 

		btfsc		Btn_status, Btn_S6	; S6 -  
		goto		LL_S5
;   
		movlw		Kn_ALL_UP
		movwf		Btn_status		;   
		pagesel		MenuInit
		goto		MenuInit		;   Kn_End		

LL_S5
		btfsc		Btn_status, Btn_S5	; S5 - / 
		goto		LongChk
		; -  
		movlw 		1 << Beeper_On		;    
		xorwf		Flags1, F
		goto		Kn_end2
		

LongChk
		btfss		Flags, long_btn
		goto		Kn_0
		bcf		Flags, long_btn
;*************************************
;-----    -----
;*************************************
; -   
		btfsc		Btn_status, Btn_S5	;S5 - 
		goto		dbg_inv
		movlw		1 << Auto_Range
		xorwf		Flags1, F		; 
		goto		Kn_end

;******
; -   
dbg_inv
		btfsc		Btn_status, Btn_S6	;S6 -  
		goto		disp_UI_inv
		movlw		1 << debug
		xorwf		Flags, F		; 
		goto		Kn_end

;******
; -        
disp_UI_inv
		btfsc		Btn_status, Btn_S4	;S4 -   
		goto		cal_on
		movlw		1 << disp_UI
		xorwf		Flags, F		; 
		goto		Kn_end

;******
; -   
cal_on
		btfsc		Btn_status, Btn_S1	;S1 -    
		goto		Fixed_LC_mode
		movlw		1 << cal_mode
		xorwf		Flags2, F		; 
		btfss		Flags2, cal_mode
		goto		Kn_cal_off
		call		Save_set	;   
		bsf			Flags1, S_P		; - 0,  - 1  
		call		ClrDSP			; OPEN ,  ..
		movlw		LOW _Cal
		call		Read_String
		movlw		LOW _Open
		call		Read_String
		call		SecLine
		movlw		LOW _start
		call		Read_String
		goto		Kn_end

;******
Fixed_LC_mode
		btfsc		Btn_status, Btn_S3	;S3 -    LC
		goto		LOAD_cal_on
		btfss		Flags3, fixed_C
		goto		C_on
		bcf			Flags3, fixed_C
		bsf			Flags3, fixed_L
		goto		Kn_end2 ;    
C_on		
		bsf			Flags3, fixed_C
		bcf			Flags3, fixed_L
		goto		Kn_end2 ;    

;******
LOAD_cal_on
		btfsc		Btn_status, Btn_S2	;S2 -   Zsm
		goto		Kn_end
		movlw		1 << LOAD_cal_mode
		xorwf		Flags2, F		; 
		btfss		Flags2, LOAD_cal_mode
		goto		Kn_cal_off
		call		Save_set	;   
		call		ClrDSP
		movlw		LOW _Cal
		call		Read_String
		movlw		LOW _Load
		call		Read_String
		movf		Range, W
		call		NumLCD
		call		SecLine
		movlw		LOW _start
		call		Read_String
		goto		Kn_end
		
;=============================================
; -  ,    ?
Kn_0	
		btfsc		Flags2, LOAD_cal_mode
		goto		Kn_cal2
		btfsc		Flags, debug
		goto		db_kn
		btfss		Flags2, cal_mode
		goto		Kn_meas
;*****************************
;------   -----
;*****************************
		btfsc		Btn_status, Btn_S1
		goto		Kn_cal2
		movlw		1 << S_P
		xorwf		Flags1, F	; 
		call		ClrDSP
		movlw		LOW _Cal
		call		Read_String
		movlw		LOW _Open
		btfss		Flags1, S_P
		movlw		LOW _Short
		call		Read_String
		call		SecLine
		movlw		LOW _start
		call		Read_String
		goto		Kn_end

Kn_cal2
		btfsc		Btn_status, Btn_S2
		goto		Kn_cal_off
		bsf			Flags1, Auto_Range
		bcf			Flags1, hold
		clrf		Freq	;   100
		call		Set_Freq
		clrf		m_count	;     10 
		; OPEN/SHORT 
		btfsc		Flags2, cal_mode
		bsf			Flags2, cal_start
		; LOAD 
		btfsc		Flags2, LOAD_cal_mode
		bsf			Flags2, LOAD_cal_start
		goto		Kn_end

Kn_cal_off
		bcf			Flags2, cal_mode
		bcf			Flags2, LOAD_cal_mode
		call		Restore_set
		goto		Kn_end

;****************************
;------   -----
;****************************
;
Kn_meas
		btfsc		Btn_status, Btn_S1
		goto		Kn_1
Kn_freq
		incf		Freq, F
		movf		Freq, W
		sublw		3
		btfsc		STATUS, Z
		clrf		Freq
		call		Set_Freq
		goto		Kn_end2 ;    

;******
; -   
Kn_1
		btfsc		Btn_status, Btn_S2
		goto		Kn_2
		movlw		1 << S_P
		xorwf		Flags1, F	; 
		goto		Kn_end2

;******
;     (0-LC, 1-X)
Kn_2
		btfsc		Btn_status, Btn_S3
		goto		Kn_3
		movlw		1<<fixed_L | 1<<fixed_C
		andwf		Flags3, W
		bcf			Flags3, fixed_C
		bcf			Flags3, fixed_L
		btfss		STATUS, Z
		goto		Kn_end2

		movlw		1 << LC_X
		xorwf		Flags1, F	; 
		goto		Kn_end2

;******
; RQD1 (00-R, 01-Q, 10-D)
Kn_3
		btfsc		Btn_status, Btn_S4
		goto		Kn_4
		movlw		b'00000011' << RQD1
		andwf		Flags1, W	;   
		sublw		b'00000010' << RQD1
		btfss		STATUS, Z
		goto		inc_RQD
		movlw		~(b'00000011' << RQD1)
		andwf		Flags1, F	;  RQD2:RQD11
		goto		Kn_end2
inc_RQD
		movlw		1 << RQD1
		addwf		Flags1, F	; (RQD2:RQD1)+1
		goto		Kn_end2

;******
;  
Kn_4
		btfsc		Btn_status, Btn_S5	;S5 - 
		goto		Kn_5
		btfss		Flags1, Auto_Range
		goto		inc_range
		bcf			Flags1, Auto_Range	;    , 
		goto		Kn_end
inc_range		
		incf		Range, F
		movf		Range, W
		sublw		.8
		btfsc		STATUS, Z
		clrf		Range
		goto		Kn_end

;******
; -    
Kn_5
		btfsc		Btn_status, Btn_S6
		goto		Kn_end
		movlw		1 << hold
		xorwf		Flags1, F	; 
		btfss		Flags1, hold
		goto		Kn_end
		movlw		0xC0+.14
		call		CmdLCD
		movlw		"H"
		call		CharLCD
		goto		Kn_end

;***************************
;------   ------
;***************************
;-----
db_kn
		;
		btfsc		Btn_status, Btn_S1
		goto		db_kn1
		goto		Kn_freq

;-----
db_kn1
		btfsc		Btn_status, Btn_S2	; Rs 100 1k 10k 100k
		goto		db_kn2
		movlw		b'00000011' << db_RanA
		andwf		db_flags, W	;   
		sublw		b'00000011' << db_RanA
		btfss		STATUS, Z
		goto		inc_RanBA
		movlw		~(b'00000011' << db_RanA)
		andwf		db_flags, F	;  db_RanB:db_RanA
		goto		Kn_end

inc_RanBA
		movlw		1 << db_RanA
		addwf		db_flags, F	; (db_RanB:db_RanA)+1
		goto		Kn_end

;-----
db_kn2
		btfsc		Btn_status, Btn_S3	; Ku=1-1 10-1 1-10 100
		goto		db_kn3
		movlw		b'00000011' << db_Mul10
		andwf		db_flags, W	;   
#ifdef TL082
		sublw		b'00000011' << db_Mul10
#endif
#ifdef PGA103
		sublw		b'00000010' << db_Mul10
#endif
		btfss		STATUS, Z
		goto		inc_Ku
		movlw		~(b'00000011' << db_Mul10)
		andwf		db_flags, F	;  db_Mul100:db_Mul10
		goto		Kn_end

inc_Ku
		movlw		1 << db_Mul10
		addwf		db_flags, F	; (db_Mul100:db_Mul10)+1
		goto		Kn_end
		
;-----
db_kn3
		btfsc		Btn_status, Btn_S4	;   
		goto		db_kn4		; Re(90) Im(0) Re-Im
		movlw		b'00000011' << db_Re
		andwf		db_flags, W	;   
		sublw		b'00000011' << db_Re
		btfss		STATUS, Z
		goto		inc_Im_Re
		bcf			db_flags, db_Im
		bsf			db_flags, db_Re
		goto		Kn_end

inc_Im_Re
		movlw		1 << db_Re
		addwf		db_flags, F	; (db_Im:db_Im)+1
		goto		Kn_end

;-----
db_kn4
		btfsc		Btn_status, Btn_S5	;  
		goto		Kn_end		; U - I
		movlw		1 << U_I
		xorwf		PORTA_copy, F	; 
		movf		PORTA_copy, W
		movfw		PORTA
		goto		Kn_end
		
;-----------   
Kn_end2
		pagesel		EE_Save_set
		call		EE_Save_set
		pagesel		$
;-----------		
Kn_end
		movlw		Kn_ALL_UP
		movwf		Btn_status
;========================================================
;   
Measure
		btfsc		Flags2, cal_start
		goto		Measure_U

		btfsc		Flags2, LOAD_cal_start
		goto		Measure_U

		btfsc		Flags, debug
		goto		db_measure
		
		btfsc		Flags2, cal_mode	; OPEN/SHORT 
		goto		next_btn_chk

		btfsc		Flags2, LOAD_cal_mode	; LOAD 
		goto		next_btn_chk
		
chk_hold
		btfss		Flags1, hold	; 
		goto		Measure_U
next_btn_chk
		call		Delay_5_ms		;      
		call		Delay_5_ms
		goto		Kn_work_1

;-----------------------
;  
;
Measure_U
		bcf			Flags2, ADC_ovl	;   
		call		Set_range_U
		; 
		bcf			PORTA_copy, U_I	; 
		movf		PORTA_copy, W
		movwf		PORTA
		bsf			PORTC, ClkSel	; 90_Clk
		movlw		ADC_U_Re
		call		ADC_and_save
		call		Check_High	;   
		iorlw		0
		btfss		STATUS, Z
		goto		Kn_work_1
		; 
		bcf			PORTC, ClkSel	; 0_Clk
		movlw		ADC_U_Im
		call		ADC_and_save
		call		Check_High	;   
		iorlw		0
		btfss		STATUS, Z
		goto		Kn_work_1
		call		Check_Low	;   
		iorlw		0
		btfss		STATUS, Z
		goto		Kn_work_1

		
;
		call		Set_range_I
		; 
		bsf			PORTA_copy, U_I	; 
		movf		PORTA_copy, W
		movwf		PORTA
		bsf			PORTC, ClkSel	; 90_Clk
		movlw		ADC_I_Re
		call		ADC_and_save
		call		Check_High	;   
		iorlw		0
		btfss		STATUS, Z
		goto		Kn_work_1
		; 
		bcf			PORTC, ClkSel	; 0_Clk
		movlw		ADC_I_Im
		call		ADC_and_save
		call		Check_High	;   
		iorlw		0
		btfss		STATUS, Z
		goto		Kn_work_1
		call		Check_Low	;   
		iorlw		0
		btfss		STATUS, Z
		goto		Kn_work_1

;     , .   ,  
		call		Set_range_U
		; 
		bcf			PORTA_copy, U_I	; 
		movf		PORTA_copy, W
		movwf		PORTA
		bsf			PORTC, ClkSel	; 90_Clk

		call		Check_dev	; 
		goto		Main_calc

;=====================================================
;     
; :
;	W=0 -    . 
;	W=1 - ,  
;  ADC_ovl   
Check_High
		movf		ADC_H, W
		andlw		b'01111111'	; 
		xorlw		HIGH .20001
		btfss		STATUS, Z
		retlw		0
		movf		ADC_L, W
		xorlw		LOW .20001
		btfss		STATUS, Z
		retlw		0
		bsf			Flags2, ADC_ovl	;   
		btfss		Flags1, Auto_Range
		retlw		0	;  
		btfss		PORTA_copy, U_I
		goto		Inc_Range
		;  ,    
		goto		Dec_Range

;=====================================================
;   Re  Im < 1792 (0x700)
; :
;	W=0 -    . 
;	W=1 -   ,  
Check_Low
		movlw		ADC_U_Re
		btfsc		PORTA_copy, U_I
		movlw		ADC_I_Re
		movwf		FSR
		bcf			STATUS, C
		rlf			m_count, W	;    2
		addlw		1	;    
		addwf		FSR, F	;  Re,  
		movlw		b'01111111'
		andwf		INDF, W	;  
		sublw		6	; W=6-W
		btfss		STATUS, C
		retlw		0
		movlw		.20
		addwf		FSR, F	;  Im,  
		movlw		b'01111111'
		andwf		INDF, W	;  
		sublw		6	; W=6-W
		btfss		STATUS, C
		retlw		0

		btfss		Flags1, Auto_Range
		retlw		0	;  
		btfss		PORTA_copy, U_I
		goto		Dec_Range
		;  ,    
		goto		Inc_Range

;-----------------------
Inc_Range
		movlw		.7
		subwf		Range, W
		btfsc		STATUS, Z
		retlw		0	;  ,   
		incf		Range, F
disp_range_and_ret
		;  
		movlw		0xC0+.14
		call		CmdLCD
		movlw		"A"
		call		CharLCD
		movf		Range, W
		call		NumLCD
		retlw		1
;-----------------------
Dec_Range
		movf		Range, F
		btfsc		STATUS, Z
		retlw		0	;  ,   
		decf		Range, F
		goto		disp_range_and_ret
;=====================================================
;:  |(i)-(i-1)|>30,  
;  ,  (i)
Check_dev
		movlw		4
		movwf		Temp3
		movlw		.9
		movf		m_count, F
		btfss		STATUS, Z
		decf		m_count, W	;    
		movwf		Temp1	;  
		bcf			STATUS, C
		rlf			Temp1, F	;    2
		movlw		ADC_U_Re
		addwf		Temp1, F

		movlw		ADC_U_Re
		movwf		Temp2
		bcf			STATUS, C
		rlf			m_count, W	;    2
		addwf		Temp2, F	;  

calc_deviation		
		movf		Temp2, W	;   
		movwf		FSR
		movf		INDF, W
		movwf		AARGB1	; 
		incf		FSR, F
		movf		INDF, W
		movwf		AARGB0	; 
		
		movf		Temp1, W	;   
		movwf		FSR
		movf		INDF, W
		movwf		BARGB1	; 
		incf		FSR, F
		movf		INDF, W
		movwf		BARGB0	; 

		movlw		b'10000000'
		xorwf		BARGB0, F	;    
		movlw		AARGB0
		call		d_code	;     .
		movlw		BARGB0
		call		d_code
		call 		Sum16_AB	; A=A+B
		call		Abs16_A	;  
		movlw		((-.30)& 0xFF00) >> 8
		movwf		BARGB0
		movlw		(-.30)& 0x00FF
		movwf		BARGB1
		call 		Sum16_AB	; A=A+B
		btfss		AARGB0,7
		goto		Clr_ADC2	;        
		movlw		.20
		addwf		Temp1, F
		addwf		Temp2, F
		decfsz		Temp3, F
		goto		calc_deviation

;  4-      +- 30 
		btfss		Flags3, Capt_L
		goto		IncCapt
		btfsc		Flags3, Capt_H
		return				;Capt_L = Capt_H = 1  == 3 (  )
IncCapt
		movlw		1<<Capt_L
		addwf		Flags3, F
		btfss		Flags3, Capt_L
		return
		btfss		Flags3, Capt_H
		return
		pagesel		CaptureBeep	; ,   -> 
		call		CaptureBeep
		pagesel		$
		return
		
;-----------------------------------------------
;     . 
d_code
		movwf		FSR
		btfss		INDF, 7
		return
		bcf			INDF, 7	;  
		comf		INDF, F	;  
		decf		FSR, F
		comf		INDF, F	;  
		incfsz		INDF, F	; 
		return
		incf		FSR, F	;   
		incf		INDF, F
		return
;-----------------------------------------------
;  
Abs16_A
		btfss		AARGB0,7
		return
		movlw		1
		subwf		AARGB1, F	; 
		btfss		STATUS, C
		decf		AARGB0, F
		comf		AARGB1, F	;  
		comf		AARGB0, F	;  
		return

;-----------------------------------------------
;16-  A=A+B
Sum16_AB
		movf		BARGB1, W
		addwf       AARGB1, F	; 

		movf		BARGB0, W	; 
		btfsc 		STATUS, C
		incfsz		BARGB0, W
		addwf		AARGB0, F
		return

;=====================================================
;  
db_measure
		call		Set_db_ragne
		clrf		m_count	;       
		btfss		db_flags, db_Re ;  Re, 90_Clk,  
		goto		db_m
		; 
		bsf			PORTC, ClkSel	; 90_Clk
		movlw		ADC_U_Re
		call		ADC_and_save

db_m
		btfss		db_flags, db_Im ;  Im, 0_Clk,  
		goto		db_disp
		bcf			PORTC, ClkSel	; 0_Clk
		movlw		ADC_U_Im
		call		ADC_and_save
		goto		db_disp

;========================================================
; 
Main_calc
		;c      float32
		movlw		ADC_U_Re
		movwf		X0	;
		movlw		U_Re0
		movwf		X1	;
		call		ADC_Sum
		
		movlw		ADC_U_Im
		movwf		X0	;
		movlw		U_Im0
		movwf		X1	;
		call		ADC_Sum

		movlw		ADC_I_Re
		movwf		X0	;
		movlw		I_Re0
		movwf		X1	;
		call		ADC_Sum

		movlw		ADC_I_Im
		movwf		X0	;
		movlw		I_Im0
		movwf		X1	;
		call		ADC_Sum

		;
		clrw
		iorwf   	I_Re0, W
		iorwf		I_Im0, W
		btfsc		STATUS,Z   ; ,     
		goto		Disp_ovl
		btfsc		Flags2, ADC_ovl	; 
		goto		Disp_ovl
		;  -    
		movf		Range, W
		movwf		Temp1
		bcf			STATUS, C
		rlf			Temp1, F
		rlf			Temp1, F	;  4

		pagesel		EEPROM_To_A
		movlw		LOW K_0	;
		addwf		Temp1, W	;  -  EEPROM
		call		EEPROM_To_A
		movlw		X0
		call		Copy_From_A	; -, ..   . B 
		movlw		U_Re0
		call		Copy_To_B
		call		FPM32	; K(range)*Z_Re
		movlw		U_Re0
		call		Copy_From_A
		movlw		X0
		call		Copy_To_A
		movlw		U_Im0
		call		Copy_To_B
		call		FPM32	; K(range)*Z_Im
		movlw		U_Im0
		call		Copy_From_A
		pagesel		$

		btfss		Flags2,	LOAD_cal_start
		goto		calc_1
		pagesel		LOAD_cal_proc
		goto		LOAD_cal_proc	;   Kn_work

calc_1
		pagesel		$
		btfss		Flags2,	cal_start
		goto		calc_comp
		pagesel		Div_UI
;		btfsc		Flags1, S_P	;0-  , 1-
;		call		Swap_UI		;     U  I
		call		Div_UI
		pagesel		$
		goto		Calibration	;   Kn_work

calc_comp
		pagesel		Div_UI		
		call		Div_UI		; U/I,    Z   Y
		pagesel		$

		pagesel		OSL_Cor
		call		OSL_Cor		; Open/Short/Load 

		pagesel		Calc_NZ
		call		Calc_NZ		;      
		pagesel		$

;========================================================
;   .  
;--------------------------------------------------------
		btfsc		Flags, disp_UI
		goto		Disp_UI_for_test
		call		ClrDSP
		
		movlw		b'00000011' << RQD1
		andwf		Flags1, W	;00-R, 01-Q, 10-D
		btfsc		STATUS, Z
		goto		disp_R
		sublw		1 << RQD1
		btfss		STATUS, Z
		goto		disp_D
;------  Q ------
		movlw		"Q"
		call		CharLCD
		call		DispSP
		pagesel		Copy_To_A
		movlw		Z_Im0
		call		Copy_To_A
		movlw		Z_Re0
		call		Copy_To_B
		call		FPD32	;Q=Z_Im/Z_Re
		movlw		b'01111111'
		andwf		AARGB0, F	;  
		pagesel		$
		movlw		0x31	;  3,   - 1 
		movwf		Low_Lim	;   0.1
		call		Disp_A
		goto		disp_LCX
;------  D ------
disp_D
		movlw		"D"
		call		CharLCD
		call		DispSP
		pagesel		Copy_To_A
		movlw		Z_Re0
		call		Copy_To_A
		movlw		Z_Im0
		call		Copy_To_B
		call		FPD32	;Q=Z_Re/Z_Im
		movlw		b'01111111'
		andwf		AARGB0, F	;  
		pagesel		$
		movlw		0x34	;  3,   - 4 
		movwf		Low_Lim	;   0.0001
		call		Disp_A
		goto		disp_LCX
;------  R ------
disp_R
		btfss		Flags1, S_P	;   Rp=1/Gp
		goto		disp_R_1
		movlw		LOW E0	;  1
		pagesel		Prog_To_A
		call		Prog_To_A
		movlw		Z_Re0
		call		Copy_To_B
		call		FPD32	;A=A/B
		movlw		Z_Re0
		call		Copy_From_A
		pagesel		$

disp_R_1
		movlw		"R"
		call		CharLCD
		call		Disp_S_P

		movlw		LOW E9	; 1E9 - ,    R
		pagesel		Prog_To_A
		call		Prog_To_A
		movlw		Z_Re0
		call		Copy_To_B
		bcf			BARGB0, 7	;  
		call		TAGTB32	; A>B ->  W=1,  W=0
		pagesel		$
		sublw		1
		btfsc		STATUS, Z
		goto		disp_R_2
		movlw		LOW _Out
		call		Read_String
		goto		disp_LCX

disp_R_2
		movlw		0x34	;  3,   - 4 
		movwf		Low_Lim	;   0.0001
		movlw		Z_Re0
		call		Disp_val
		movlw		1	; 
		call		CharLCD

;------   ------
disp_LCX
		;Freq 0-100, 1-1000, 2-10
		swapf		NZ, F
		;     Xp=-1/Z_Im,  L     
		;   
		btfss		Flags1, S_P
		goto		disp_LCX_1	;   
		movlw		LOW E0	;  1
		pagesel		Prog_To_A
		call		Prog_To_A
		movlw		Z_Im0
		call		Copy_To_B
		call		FPD32	;A=A/B
		movlw		b'10000000'
		xorwf		AARGB0, F	;  -/+
		movlw		Z_Im0
		call		Copy_From_A
		pagesel		$

disp_LCX_1
		bcf			STATUS, C
		rlf			Freq, W	;*2
		movwf		Temp1
		rlf			Temp1, F	;*2
		movlw		LOW	w100_1
		addwf		Temp1, W
		pagesel		Prog_To_A
		call		Prog_To_A	; 1/W = 1/(2*Pi*F) -->  .
		pagesel		$

		call		SecLine
		btfss		Flags1, LC_X
		goto		disp_LC
; X
		movlw		"X"
		call		CharLCD
		call		Disp_S_P
		movlw		0x34	;  3,   - 4 
		movwf		Low_Lim	;   0.0001
		movlw		Z_Im0
		call		Disp_val
		movlw		1	; 
		call		CharLCD
		goto		F_disp

;-------------------
disp_LC
		btfss		db_flags, L_C	; 0-L, 1-C
		goto		disp_L	; 

;-------------------
disp_C	; Cs=1/(W*Xs)
		movlw		b'10000000'
		xorwf		Z_Im1, F	; ,  
		pagesel		Copy_To_B
		movlw		Z_Im0
		call		Copy_To_B
		call		FPD32	;A=1/W/Xs
		pagesel		$
		movlw		"C"
		call		CharLCD
		call		Disp_S_P
		call		Disp_auto
		call		Set_Low_Lim_C	;    
		call		Disp_A
		movlw		"F"		;
		call		CharLCD
		goto		F_disp

;-------------------
disp_L	;Ls=Xs/W
		pagesel		Copy_To_B
		movlw		Z_Im0
		call		Copy_To_B
		call		FPM32	;A=Xs/w
		pagesel		$
		movlw		"L"
		call		CharLCD
		call		Disp_S_P
		call		Disp_auto
		call		Set_Low_Lim_L	;    
		call		Disp_A
		movlw		"H"		;
		call		CharLCD
		goto		F_disp

;-------------------
F_disp
		; 		
		movlw		0x80+.13
		call		CmdLCD
		call		Freq_disp

		;  
		btfss		Flags1, Auto_Range
		goto		d_range
		movlw		0xC0+.14
		call		CmdLCD
		movlw		"A"
		call		CharLCD
d_range
		movlw		0xC0+.15
		call		CmdLCD
		movf		Range, W
		call		NumLCD
		pagesel		tst_LOAD
		call		tst_LOAD	; !   
		pagesel		U_bias
		call		U_bias
		pagesel		$

		goto		Kn_work

;-------------------------------
;
; "s"   
; "p"   
Disp_S_P
		movlw		"p"
		btfss		Flags1, S_P
		movlw		"s"
		call		CharLCD
		call		DispSP
		return

;-------------------------------
;    
;  L  C
Disp_auto
		movlw		1<<fixed_L | 1<<fixed_C
		andwf		Flags3, W
		btfss		STATUS, Z
		return
		movlw		0xC0+2
		call		CmdLCD
		movlw		0x07	;   
		call		CharLCD
		call		DispSP
		return

;-------------------------------
; 
Disp_ovl
		btfsc		Flags, disp_UI
		goto		Disp_UI_for_test
		call		ClrDSP
		movlw		LOW _Ovl
		call		Read_String
		goto		F_disp

;-------------------------------
;      
Disp_UI_for_test
		call		ClrDSP
		movlw		"U"
		call		CharLCD
;		call		DispSP
		movlw		ADC_U_Re
		call		tst_ind1

		call		DispSP
		movlw		ADC_U_Im
		call		tst_ind1
		
		call		SecLine
		movlw		"I"
		call		CharLCD
;		call		DispSP
		movlw		ADC_I_Re
		call		tst_ind1
		
		call		DispSP
		movlw		ADC_I_Im
		call		tst_ind1
		
		goto		Kn_work

tst_ind1
		movwf		FSR
		bcf			STATUS, C
		rlf			m_count, W	; * 2
		addwf		FSR, F
		movf		INDF, W
		movwf		AARGB3	; 
		incf		FSR, F
		movf		INDF, W
		movwf		AARGB2	; 
		clrf		AARGB1
		clrf		AARGB0
		btfss		AARGB2,7 ; "-"
		goto		tst_ind2
		bcf			AARGB2, 7	; "-"
		movlw		"-"
		call		CharLCD
tst_ind2
		call		BCD
		movlw		BCD2
		call		Disp_Full	;  
		return
;-----------------------------------------------------
;-----  .   -----
;-----------------------------------------------------
db_disp
		call		ClrDSP
		movlw		"I"
		btfss		PORTA_copy, U_I
		movlw		"U"
		call		CharLCD
		movlw		ADC_U_Re
		call		tst_ind1

		call		DispSP
		movlw		ADC_U_Im
		call		tst_ind1
		
		call		SecLine
		;  Rs
		movlw		1<<db_RanA | 1<<db_RanB
		andwf		db_flags, W
		bcf			STATUS, C
		movwf		Temp1
		rrf			Temp1, F
		rrf			Temp1, F ;  db_RanB  db_RanA   
		movlw		LOW _100_Om
		decfsz		Temp1, F
		goto		$+2
		movlw		LOW _1k
		decfsz		Temp1, F
		goto		$+2
		movlw		LOW _10k
		decfsz		Temp1, F
		goto		$+2
		movlw		LOW _100k
		call		Read_String
		call		DispSP
		;  Ku
		movlw		1<<db_Mul10 | 1<<db_Mul100
		andwf		db_flags, W
		movwf		Temp1
		movlw		LOW _1_1	;1-1
		decfsz		Temp1, F
		goto		$+2

#ifdef TL082
		movlw		LOW _10_1	;10-1
		decfsz		Temp1, F
		goto		$+2
		movlw		LOW _1_10	;1-10
		decfsz		Temp1, F
		goto		$+2
		movlw		LOW _10_10	;100
#endif

#ifdef PGA103
		movlw		LOW _1_10	;1-10
		decfsz		Temp1, F
		goto		$+2
		movlw		LOW _10_10	;100
#endif

		call		Read_String
		call		DispSP
		;  Re-Im
		movlw		LOW _RI
		btfsc		db_flags, db_Re
		goto		$+2
		movlw		LOW _Im
		btfsc		db_flags, db_Im
		goto		$+2
		movlw		LOW _Re
		call		Read_String
		call		DispSP
		; 		
		movlw		0xC0+.13
		call		CmdLCD
		call		Freq_disp

		goto		Kn_work

;----------------------------------------------------
; 		
;----------------------------------------------------
Freq_disp
		movf		Freq, W
		movwf		Temp1
		movlw		LOW _100
		decfsz		Temp1, F
		goto		$+2
		movlw		LOW _1k
		decfsz		Temp1, F
		goto		$+2
		movlw		LOW _10k
		call		Read_String
		return

;----------------------------------------------------
;    
;   
; Zsc Yo  100, 1, 10    EEPROM
;----------------------------------------------------
Calibration
		call		SecLine	;   
		movf		m_count, W
		call		NumLCD
		call		DispSP
		call		Freq_disp
		
		movf		m_count, W
		sublw		.9
		btfss		STATUS, Z
		goto		Kn_work		
		;  Zin
		movlw		Z_Re0	;  
		pagesel		Copy_To_A
		call		Copy_To_A
		pagesel		$
		call		Freq_mult_8	;   Temp1
		movlw		LOW Zo
		btfss		Flags1, S_P ; - 0 (SHORT),  - 1 (OPEN)
		movlw		LOW Zs
		addwf		Temp1, W
		movwf		X0	;  , .. Temp1   Copy_To_A
		pagesel		A_To_EEPROM
		call		A_To_EEPROM
		movlw		Z_Im0	;  
		call		Copy_To_A
		movf		X0, W
		addlw		4	;    . 
		call		A_To_EEPROM
		pagesel		$
		;    
		movf		Freq, W
		sublw		2		;   - 10
		btfsc		STATUS, Z
		goto		end_cal
		incf		Freq, F
		call		Set_Freq
		goto		Kn_work

end_cal
		bcf			Flags2, cal_start
		bcf			Flags2, cal_mode
		call		Restore_set
		goto		Kn_work


;------------------------------------------------------
;   8     EEPROM
; : Temp1=Freq*8
Freq_mult_8
		movf		Freq, W
		movwf		Temp1
		bcf		STATUS, C
		rlf		Temp1, F	;    8
		rlf		Temp1, F	;    
		rlf		Temp1, F	;  EEPROM
		return

;----------------------------------------------------
;  
;      W + (2 * m_count)
;   = 1   
;----------------------------------------------------
ADC_and_save
		movwf		Temp1	;  
		bsf			Flags, go_ADC	; 
		btfsc		Flags, go_ADC	;  
		goto		$-1
		;     
		movf		m_count, W
		movwf		FSR
		bcf			STATUS, C
		rlf			FSR, F	;    2
		movf		Temp1, W
		addwf		FSR, F	;    
		movf		ADC_L, W
		movwf		INDF	;  
		incf		FSR, F
		movf		ADC_H, W
		movwf		INDF	;  
		return

;------------------------------------------------------------
; Set_Freq
;    100  ,   
;   RC2 (CCP1)  Timer2 
;	Freq:	 0-100, 1-1000, 2-10
;------------------------------------------------------------
Set_Freq
		; 
		banksel		Freq
		movlw 		HIGH Table
		movwf 		PCLATH
		bsf			Flags2,U_no_disp1
		bsf			Flags2,U_no_disp2
		movlw		LOW (Period_SinClk-1)
		addwf		Freq, W
		call		Table	;   
		banksel		PR2
		movwf		PR2	; =100
		;  
		banksel		Freq
		clrf		CCP1CON
		movlw		LOW (Width_SinClk-1)
		addwf		Freq, W
		call		Table	;   
		movwf		Temp1
		rrf			Temp1, F
		btfsc		STATUS, C
		bsf			CCP1CON, 4	; ,   (0)
		rrf			Temp1, W
		btfsc		STATUS, C
		bsf			CCP1CON, 5	; ,  N 1
		andlw		0x3F
		movwf		CCPR1L		;  - 
		; TMR2
		movlw		b'00000100' ;- =1:1
		movf		Freq, F
		btfsc		STATUS, Z	; 100    4
		movlw		b'00000101' ;- =1:4
		movwf		T2CON		;. TMR2
		movlw		0x0F
		iorwf		CCP1CON,F	;. CCP1   
		;  
		movlw		b'11001111' ;  10
		andwf		PORTA_copy, F
		movf		Freq, W
		sublw		1	;1000?
		btfsc		STATUS, Z
		bsf			PORTA_copy, F_1
		movf		Freq, F
		btfsc		STATUS, Z
		bsf			PORTA_copy, F_2	;100
		movf		PORTA_copy, W
		movwf		PORTA
		;    100   100
		movf		Freq, F	;Freq=0  100
		movlw		Clc250k		;F=Fosc/(4*(N+1),  250 N=15
		btfsc		STATUS, Z
		movlw		Clc100k		;F=Fosc/(4*(N+1),  100 N=39
		
		btfsc		Flags3, ADC_100kHz	;   100   
		movlw		Clc100k
		
		banksel		SPBRG
		movwf		SPBRG
		banksel		PORTA
		return
;------------------------------------------------------------
; Set_range_I
;   ,    Range
;  
;	  R		_U	K_I
;0	100 	100	1
;1	100 	10	1
;2	100 	1	1
;3	1 	1	1
;4	10 	1	1
;5	100 	1	1
;6	100 	1	10
;7	100 	1	100
;------------------------------------------------------------
Set_range_U
		movlw 		HIGH Table	;     
		movwf 		PCLATH
		movlw		LOW (Range_code-1)
		addwf		Range, W
		call		Table	;   
		movwf		Temp1
		; R
		movf		PORTB, W
		andlw		~(1<<RanA | 1<<RanB)	;b'11001111'
		movwf		Temp2
		btfsc		Temp1, 4	;RanA
		bsf		Temp2, RanA
		btfsc		Temp1, 5	;RanB
		bsf		Temp2, RanB
		movf		Temp2, W
		movwf		PORTB
		; K_U
		movlw		~(1<<Mul10 | 1<<Mul100)	; b'11110011'
		andwf		PORTA_copy, F
#ifdef TL082			;    TL082    
		btfss		Temp1, 3	;U_Mul100
		bsf		PORTA_copy, Mul100
		btfss		Temp1, 2	;U_Mul10
		bsf		PORTA_copy, Mul10
#endif
#ifdef PGA103			;    PGA103     
		btfsc		Temp1, 3	;U_Mul100
		bsf		PORTA_copy, Mul100
		btfsc		Temp1, 2	;U_Mul10
		bsf		PORTA_copy, Mul10
#endif
		movf		PORTA_copy, W
		movwf		PORTA
		return
;------------------------------------------------------------
; Set_range_I
;     Mul10, Mul100,
; .. RanA RanB  
;------------------------------------------------------------
Set_range_I
		movlw		LOW (Range_code-1)
		addwf		Range, W
		call		Table	;   
		movwf		Temp1
		; K_I
		movlw		~(1<<Mul10 | 1<<Mul100)	; b'11110011'
		andwf		PORTA_copy, F
#ifdef TL082			;    TL082    
		btfss		Temp1, 1	;I_Mul100
		bsf		PORTA_copy, Mul100
		btfss		Temp1, 0	;I_Mul10
		bsf		PORTA_copy, Mul10
#endif
#ifdef PGA103			;    PGA103     
		btfsc		Temp1, 1	;I_Mul100
		bsf		PORTA_copy, Mul100
		btfsc		Temp1, 0	;I_Mul10
		bsf		PORTA_copy, Mul10
#endif
		movf		PORTA_copy, W
		movwf		PORTA
		return

;------------------------------------------------------------
; Set_db_ragne
;     
;
;------------------------------------------------------------
Set_db_ragne
		;   
		movlw		~(1<<RanA | 1<<RanB)	;b'11001111'
		andwf		PORTB, W
		movwf		Temp1
		movlw		1<<db_RanA | 1<<db_RanB 
		andwf		db_flags, W
		bcf		STATUS, C
		movwf		Temp2
		rrf		Temp2, F
		rrf		Temp2, F ;  db_RanB  db_RanA   
		clrw		;100 
		decfsz		Temp2, F
		goto		$+2
		movlw		1<<RanA	;1
		decfsz		Temp2, F
		goto		$+2
		movlw		1<<RanB	;10
		decfsz		Temp2, F
		goto		$+2
		movlw		1<<RanA | 1<<RanB	;100
		iorwf		Temp1, W
		movwf		PORTB

		;    ( - )
		movlw		~(1<<Mul10 | 1<<Mul100)		; b'11110011'
		andwf		PORTA_copy, F			;   - 

		movlw		1<<db_Mul10 | 1<<db_Mul100	; b'00000011'
		andwf		db_flags, W			;    -  
#ifdef TL082			;    TL082    
		xorlw		1<<db_Mul10 | 1<<db_Mul100	; b'00000011' - 
#endif
		movwf		Temp2
		bcf			STATUS, C
		rlf			Temp2, F	;      
		rlf			Temp2, W
		iorwf		PORTA_copy, F
		movf		PORTA_copy, W
		movwf		PORTA
		return

;------------------------------------------------------------
;    
;------------------------------------------------------------
Save_set
		movf		Flags1, W
		banksel		_Flags1
		movwf		_Flags1
		banksel		Freq
		movf		Freq, W
		banksel		_Freq
		movwf		_Freq
		banksel		0
		return

;------------------------------------------------------------
;    
;------------------------------------------------------------
Restore_set
		banksel		_Flags1
		movf		_Flags1, W
		banksel		Flags1
		movwf		Flags1
		banksel		_Freq
		movf		_Freq, W
		banksel		Freq
		movwf		Freq
		call		Set_Freq
		return


;------------------------------------------------------------
; Clr_ADC
;      
;------------------------------------------------------------
Clr_ADC
		clrf		m_count	;  -   
		movlw		ADC_U_Re + .79	;    
		movwf		FSR
		movlw		.80		; 
		banksel		Count1
		movwf		Count1
Clr_ADC_1
		clrf		INDF	;  
		decf		FSR, F	;  
		decfsz		Count1, F
		goto		Clr_ADC_1
		return
;------------------------------------------------------------
; Clr_ADC2
;      
;    (m_count)
;------------------------------------------------------------
Clr_ADC2
		bcf			STATUS, C
		rlf			m_count, W
		addlw		ADC_U_Re
		movwf		Count1
		movlw		ADC_U_Re
		movwf		FSR

clr_adc_2
		movf		Count1, W
		subwf		FSR, W
		btfss		STATUS, Z
		goto		clr_adc_3
		incf		FSR, F	;     
		incf		FSR, F
		movlw		.20
		addwf		Count1, F	;    
		goto		clr_adc_4
clr_adc_3
		clrf		INDF	;      - 
		incf		FSR, F
		clrf		INDF
		incf		FSR, F
clr_adc_4
		movlw		ADC_U_Re + .80	;,     
		subwf		FSR, W
		btfss		STATUS, Z
		goto		clr_adc_2		

		bcf		Flags3, Capt_L	;    
		bcf		Flags3, Capt_H		
		return		


;------------------------------------------------------------
; ADC_Sum
;       float32
; :
;	 X0 -    ADC_U/I_Re/Im
;	 X1 -  	U/I_Re0/Im0
;------------------------------------------------------------
ADC_Sum
		pagesel		ClrA
		call		ClrA
		call		ClrB
		pagesel		$
		
		movlw		.10
		movwf		Count1	; 
		movf		X0, W
		movwf		FSR
sum_0
		movf		INDF, W
		movwf		BARGB2	;  
		incf		FSR, F
		movf		INDF, W
		movwf		BARGB1	;  
		clrf		BARGB0
		incf		FSR, F	;   . 
		btfss		BARGB1, 7	;  ?
		goto		sum_1	;
		;  . 
		bcf			BARGB1, 7	;  
		comf		BARGB2, F	; 
		comf		BARGB1, F
		comf		BARGB0, F
		incfsz		BARGB2, F	; 
		goto		sum_1
		incfsz		BARGB1, F	;   ,
		goto		sum_1		;    -20000    .
		incf		BARGB0, F
sum_1	;24-  A=A+B
		movf		BARGB2, W
		addwf       AARGB2, F	;LS byte

		movf		BARGB1, W	;middle byte
		btfsc 		STATUS, C
		incfsz		BARGB1, W
		addwf		AARGB1, F

		movf		BARGB0, W	;MS byte
		btfsc 		STATUS, C
		incfsz		BARGB0, W
		addwf		AARGB0, F
		;--------------------
		decfsz		Count1, F
		goto		sum_0
		pagesel		FLO2432
		call		FLO2432
		movf		X1, W
		call		Copy_From_A
		pagesel		$
		return


;------------------------- Delay -------------------------
;	 
;       

Delay_05_sec		; 0.5 
#ifdef OSC16	;  16Hz
		Dly24	D'124999'   ; 0.5/(4/16000000)/16=125000-1=124999
#endif
#ifdef OSC20	;  20Hz
		Dly24	D'156249'   ; 0.5/(4/20000000)/16=156250-1=156249
#endif
		goto	DoDly24
;-------------------------
Delay_50_ms	; 50 
#ifdef OSC16	;  16Hz
		Dly24	D'12499'   ; 0.05/(4/16000000)/16=12500-1=12499
#endif
#ifdef OSC20	;  20Hz
		Dly24	D'15619'   ; 0.05/(4/20000000)/16=15620-1=15619
#endif
		goto	DoDly24
;-------------------------
Delay_5_ms	; 5 
#ifdef OSC16	;  16Hz
		Dly24	D'1249'   ; 0.005/(4/16000000)/16=1250-1=1249
#endif
#ifdef OSC20	;  20Hz
		Dly24	D'1561'   ; 0.005/(4/20000000)/16=1562-1=1561
#endif
		goto	DoDly24
;-------------------------		
Delay_200_us	; 200 
#ifdef OSC16	;  20Hz
		Dly24	D'49'   ; 0.0002/(4/16000000)/16=50-1=49
#endif
#ifdef OSC20	;  20Hz
		Dly24	D'61'   ; 0.0002/(4/20000000)/16=62-1=61
#endif
;-------------------------
DoDly24		;16 Tcy per loop
		movlw   H'FF'      ;Start with -1 in W
		addwf   Dly0,F     ;LSB decrement
		btfsc   STATUS,C   ;was the carry flag set?
		clrw               ;If so, 0 is put in W
		addwf   Dly1,F     ;Else, we continue.
		btfsc   STATUS,C
		clrw               ;0 in W
		addwf   Dly2,F
		btfsc   STATUS,C
		clrw               ;0 in W
		iorwf   Dly0,W     ;Inclusive-OR all variables
		iorwf   Dly1,W     ;together to see if we have reached
		iorwf   Dly2,W     ;0 on all of them.
		btfss   STATUS,Z   ;Test if result of Inclusive-OR's is 0
		goto    DoDly24
		return

;**********************************************************************************************
;  subtitle "LCD2LINE - Control an LCD using 2 Lines."
;  source from Myke Predko 23.01.1997 (http://www.myke.com).
;  These routines will Initialize, Send Instructions, and Send Characters to a
;  standard Hitachi 44780 controlled LCD.  A three line interface is used to
;  reduce the number of PIC Pins used on the LCD.
;
;  NOTE:  Before the Initialization is to be executed by the PIC, 15 msecs must
;  elapse before the "Init" subroutine is called.
;
;  The Hardware is:
;
;           |                                   Gnd ----|  1   44780
;   PIC     |                                   Vcc ----|  2   Controlled
;           |                            Contrast V ----|  3   LCD
;           |                              +------------|  4
;           |                              |    Gnd ----|  5
;           |                              |     +------|  6
;           |                ________      |     |      |  7
;           |               |  Shift |     |     |      |  8
;           |               |  Reg   |     |     |      |  9
;           |               |        |     |     |      | 10
;           |_LCDClock      |      Q0|---- | --- | -----| 11
;       RB7 |---------------| Clk  Q1|---- | --- | -----| 12
;           |               |      Q2|---- | --- | -----| 13
;       RB6 |-----------+---| D    Q3|---- | --- | -----| 14
;	    |_LCDData   |   |      Q4|-----+     |
;			|   |      Q5|-----|<|---+
;			|   |________|   1N4148  |
;                       |         ____           |
;                       +--------|____|----------+
;                                 1.5k
;  Hardware Notes:
;   The Pic speed is immaterial
;   RB6 is Connected to Data Out to the LCD Control
;   RB7 is Connected to the LCD Shift Register Clock
;   The Shift Register can be any 6 bit (or more) Serial In/Parallel Out Shift Register
;   LCDTemp, LCDNTemp, LCDCount  - file Registers Used for Data Transfer
;
;  MMyke Predko

;**********************************************************************
;	 
;**********************************************************************
GetKey		call	ClrSift		;  Shift 
		clrf	Btn_now
		movlw	.6		;   6 
		movwf	Count_LCD	;   
		bsf	_LCDData	;  Data  1
		bcf	_LCDClock	;  Clock
LoopKBD
		bsf	_LCDClock	;    Clock
		bcf	_LCDClock

		banksel TrisLCD		;    Tris 
		bsf	_LCDTris	;   LCDData   - "1"
		banksel INTCON		

		goto	$+1		; Wait
		goto	$+1		; Wait
		goto	$+1		; Wait

		bsf	STATUS, C	;  Carry -   
		btfsc	_LCDData
		bcf	STATUS, C	;  Carry -> E 
		rrf	Btn_now,F	;     
		
		banksel TrisLCD		;    Tris 
		bcf	_LCDTris	;      - "0"	
		banksel INTCON
		bcf	_LCDData	;  Data -     

		decfsz	Count_LCD,F	;  
		goto	LoopKBD

		rrf	Btn_now,F	;     (8-6 )
		rrf	Btn_now,F

		movf	Btn_now, W	;  
		andlw	Kn_ALL_UP	;  
		movwf	Btn_now		;   
		return

;*************************************************************************************
;	 LCD  4-  
;*************************************************************************************
InitLCD
		bsf	_LCDBusy	;  _LCDBusy      CmdLCD
		call	Delay_5_ms
   		call	Delay_5_ms
   		call	Delay_5_ms 	;  15    
		banksel PortLCD
		bcf	_LCDCmd		; Clear RS bit LCD -> send the command
		movlw	.3
		movwf	Count1

NextRes		movlw	0x30		; Start with the Initialization
		movwf	Temp_LCD
		call	LCDNybble	; Output the Nybble
		call	Delay_5_ms	; Init wait time 5ms	
		decfsz	Count1,F
		goto	NextRes		; Loop 3 times

		movlw	0x20		; Now, Set Interface Length to 4 Bits
		movwf	Temp_LCD
		call	LCDNybble
		call	Delay_200_us

		movlw	0x28		; Set 4 Bits, 2 Lines
		call	CmdLCD		; Send to LCD

		movlw	0x0C		; Turn Display On
		call	CmdLCD

		movlw	0x01		; Clear the Display, setup the Cursor
		call	CmdLCD

		pagesel	Load_ZG
		call	Load_ZG		;    ,      
		pagesel		$
		call	Delay_200_us	;  CGRAM     0x08

   		call	ClrDSP		;  
		return

;************************************************************************************
;    1  
;************************************************************************************
CurLeft		movlw	b'00010000'	;    1  
            goto	CmdLCD
;************************************************************************************
;  
;************************************************************************************
CurOff		movlw	b'00001100'	;   
            goto	CmdLCD
;************************************************************************************
;  
;************************************************************************************
CurOn		movlw	b'00001110'	;     
            goto	CmdLCD
;************************************************************************************
;  
;************************************************************************************
ClrDSP		movlw	1
            goto	CmdLCD
;************************************************************************************
;    
;************************************************************************************
CursorHome	movlw	0x02            
            goto	CmdLCD
;************************************************************************************
;       
;************************************************************************************
SecLine		movlw	0xC0
;************************************************************************************
;        
;************************************************************************************
CmdLCD		
		banksel PortLCD
		bcf	_LCDCmd		; RS=0 - Send Command
SendLCD
		bsf	_LCDBusy	;   LCD -   KBD
		movwf	Temp_LCD
		bcf	STATUS, C
		call	LCDNybble
		call	LCDNybble
		rlf	Temp_LCD,F	; Restore original value

		call	Delay_200_us	; Wait for the LCD to Process the Instruction
		btfsc	_LCDCmd
		goto	EndLCD
		movlw	0x0FC		; "Clear Display" (0x01) and "Cursor At Home" (0x02) 
		addwf	Temp_LCD, w      ; Instructions require 5 msec Delay to Complete
		btfss	STATUS, C
		call	Delay_5_ms
EndLCD		bcf	_LCDBusy	;   -   KBD
		return

;************************************************************************************
;        ASCII   "."    "0"    
;************************************************************************************

DispDot		movlw	"."
		goto	CharLCD

Disp0		movlw	"0"
		goto	CharLCD

DispSP		movlw	" "
		goto	CharLCD

;************************************************************************************
;         ASCII  
;************************************************************************************
NumLCD		andlw	0x0F            ; 
            iorlw	0x30            ; ASCII

;************************************************************************************
;        ASCII 
;************************************************************************************
CharLCD
		banksel PortLCD
		bsf	_LCDCmd		; RS=1 Send Charicter
		goto 	SendLCD

;************************************************************************************
; Send the Nybble (with what's set in _LCDData to Begin)
;************************************************************************************
LCDNybble	call	ClrSift		; Clear the Sift Register

		bsf	_LCDData	; First bit is "Enable" signal LCD

		call	ClockLCD	; Shift the bit in the register (Q7)

		btfss	_LCDCmd		; Set the RS Bit (if RS=1 - Charicter)
		bcf	_LCDData	; else "RS" = 0 -> Command

		call	ClockLCD	; Shift the bit in the register (Q6)

		bcf	_LCDData        ; Clear data signal shift register

		call	ClockLCD	; Shift the bit in the register (Q5)
		call	ClockLCD	; Shift the bit in the register (Q4)

		movlw	4		; Now, Shift out four bits ( Data bits LCD )
		movwf	Count_LCD	; Q3-Q0

LNLoop		bcf	_LCDData	; Loop Around Here

		rlf	Temp_LCD, F	; Load Carry with the MSB
		btfsc	STATUS, C
		bsf	_LCDData	; Set the Bit (if Appropriate)

		call	ClockLCD	; Shift the bit in the register

		decfsz	Count_LCD, F	; Check for end
		goto	LNLoop

		bsf	_LCDData	; Set the 'EN' pin LCD
		goto	$+1		; Wait
		goto	$+1		; Wait
		bcf	_LCDData	; Clear the 'EN' pin LCD
		return			; Nibble bits sended to LCD

ClockLCD:
		bsf	_LCDClock	; Clock out the Bit
		goto	$+1 
		bcf	_LCDClock	; Clear the clock
		return 

;**********************************************************************
;Clear sift register uses for LCD and Keyboard
;**********************************************************************	
ClrSift		bcf	_LCDData	;  Data   0
		bcf	_LCDClock	;  Clc (  )

		movlw	8		;      
		movwf	Count_LCD	;   

ShiftLoop	bsf	_LCDClock	;    Clock
		bcf	_LCDClock

		decfsz	Count_LCD, F	;  
		goto	ShiftLoop	;    0 
		return

;**********************************************************************
;       LCD
;**********************************************************************
Read_String
		movwf	Count1
		decf	Count1,F 	;  
		movlw 	HIGH Table
		movwf 	PCLATH
get_next_s
		movf	Count1,W
		call	Table
		andlw	0xFF		;    
		btfsc	STATUS, Z
		return
		call	CharLCD
		incf	Count1,F
 		goto	get_next_s


;----------------------------------------------------------
;    W   BCD0...4
; 
Disp_Full
			movwf		FSR		;     LCD
next_byte
			swapf		INDF,W
			call		NumLCD
			movf		INDF,W
			call		NumLCD
			;,     BCD0
			movlw		BCD0
			subwf		FSR,W
			btfsc		STATUS,Z
			return
			decf		FSR,F
			goto		next_byte

;---------------------- BCD ---------------------
;	      
BCD		movlw		0x20
		movwf		T1
		clrf		BCD0
		clrf		BCD1
		clrf		BCD2
		clrf		BCD3
		clrf		BCD4

BcdLoop		rlf		AARGB3, F	; A2
		rlf		AARGB2, F	; A1
		rlf		AARGB1, F	; A0
		rlf		AARGB0, F	; Aexp

		rlf		BCD0, F
		rlf		BCD1, F
		rlf		BCD2, F
		rlf		BCD3, F
		rlf		BCD4, F
		decfsz		T1, F
		goto		Adjust
		return

Adjust		movlw		.5
		movwf		Count2

		movlw		BCD0
		movwf		FSR
		goto		ADloop+1

ADloop		incf		FSR, F
		call		Adjbcd
		decfsz		Count2, F
		goto		ADloop
		goto		BcdLoop

Adjbcd		movlw		0x03
		addwf		INDF, W
		movwf		T0		
		btfsc		T0, 3		
		movwf		INDF
		movlw		0x30
		addwf		INDF, W
		movwf		T0
		btfsc		T0, 7
		movwf		INDF
		return

;=======================================================================
;       
;-----------------------------------------------------------------------
Disp_val
		pagesel		Copy_To_A
		call		Copy_To_A
		pagesel		$
		call		Disp_A
		return
		
;=======================================================================
;       
; NZ -   
;=======================================================================
Disp_A	
		btfss		AARGB0,7 ; "-"
		goto		dsp_1
		bcf		AARGB0, 7	; "-"
		movlw		"-"
		call		CharLCD
dsp_1
		clrf		Y0		; 
		movlw		LOW E9		;  (19) 
		movwf		Y1
		swapf		Low_Lim, W
		andlw		0x0f
		movwf		Y3	;   
;   > ?
cmp_A_E
		movf		Y1, W
		pagesel		Prog_To_B
		call		Prog_To_B
		call		TAGTB32		; A>E ?
		pagesel		$
		iorlw		0		; 0 - , 1 - 
		btfss		STATUS, Z
		goto		A_GT_E
		movlw		4
		addwf		Y1, F		; . 
		incf		Y0, F
		movf		Y3, W			;   + 1
		subwf		Y0, W
		btfss		STATUS, Z
		goto		cmp_A_E		; 
		;  ,         Low_Lim
		movf		Low_Lim, W
		andlw		0x0F
		movwf		Y3	;     
		goto		disp_1a

;,  Y0 -  
A_GT_E	;A >= E
		movlw		5	;      ,
		movwf		Y3	;      NZ
disp_1a		
		movf		Y0, W	;    2 (..     6 )
		addlw		2		;    
		movwf		Y1		;    6   
		bcf		STATUS, C
		rlf		Y1, F
		rlf		Y1, F		;  (2..9)*4
		movlw		LOW E9
		addwf		Y1, W		; +
		pagesel		Prog_To_B
		call		Prog_To_B
		call		FPD32		;A=A/B,  B=1E(+/-3*N)
		call		INT3232		;   
		pagesel		$
		call		BCD

;   
		bsf		Flags, L_Z 	;    
		movf		NZ,W		;     
		andlw		0x0F		;   
		movwf		Y2

		movlw		BCD4
		call		DispBCD
		movlw		BCD4
		call		DispBCD
		
		movlw		BCD3
		call		DispBCD

		btfss		Flags, L_Z
		goto		dsp_2		;    
		swapf		BCD3, W		;    
		andlw		0x0F
		btfss		STATUS,Z
		goto		dsp_2		;     ,   
		call		Disp0
		goto		dot_out

dsp_2
		movlw		BCD3
		call		DispBCD
dot_out
		movf		Y2, F
		btfsc		STATUS, Z
		goto		prefix
		call		DispDot		;  

		movlw		BCD2
		call		DispBCD_2
		movlw		BCD2
		call		DispBCD_2

		movlw		BCD1
		call		DispBCD_2
		movlw		BCD1
		call		DispBCD_2

		movlw		BCD0
		call		DispBCD_2
		movlw		BCD0
		call		DispBCD_2

prefix
		movlw		LOW (_pref-1)
		addwf		Y0, W
		call		Table
		iorlw		0
		btfss		STATUS, Z
		goto		CharLCD
		return		;      ( ),   

;---------------------- BCD to LCD ---------------------
;	      
DispBCD_2	;  
		movwf		FSR
		movf		Y3, F
		btfsc		STATUS, Z
		return
		decf		Y3, F	;     
		
		movf		Y2, F	;  
		btfsc		STATUS, Z
		return
		
		swapf		INDF, F
		movf		INDF, W
		andlw		0x0F
		btfss		STATUS, Z
		bcf			Flags,L_Z
		call		NumLCD
		
		btfss		Flags,L_Z 	;1 -    
		decf		Y2, F
		return
		
		
DispBCD	;   
		movwf		FSR
		swapf		INDF,F
		movf		INDF,W
		btfss		Flags,L_Z 	;1 -    
		goto		chk_NZ
		andlw		0x0F
		btfsc		STATUS,Z
		return				;  
		bcf		Flags,L_Z 	;      
chk_NZ
		movf		Y2, F
		btfsc		STATUS, Z
		goto		Disp0 		;   ,  0
		decf		Y2, F
		movf		INDF,W
		call		NumLCD
		return

;----------------------        ---------------------
;Set_Low_Lim_X
;		btfss		Z_Im1, 7	;1 () - , 0 () - 
;		goto		Set_Low_Lim_L

Set_Low_Lim_C
		movlw 		HIGH Table	;     
		movwf 		PCLATH
		movlw		LOW (min_C-1)
		addwf		Freq, W
		goto		get_lim

Set_Low_Lim_L
		movlw 		HIGH Table	;     
		movwf 		PCLATH
		movlw		LOW (min_L-1)
		addwf		Freq, W
get_lim
		call		Table	;     
		movwf		Low_Lim
		return

;=======================================================
; .    0x700
; ( 256     )
		include "tables.inc"         
;////////////////////////////////////////////////////////////////////////////////////
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;                   P A G E   N 1
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;////////////////////////////////////////////////////////////////////////////////////

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;     PIC16 24 BIT FLOATING POINT LIBRARY
;    1-   
;    pagesel
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define P16_MAP1 0
#define P16_MAP2 1
		org		0x800

        include "math16.inc"
        include "fp32.a16"
        include	"taxxb32.a16"
        
        include "complex.inc"	;      

;-------------------------------------------------------
;
;  /     FPL32
;
;-------------------------------------------------------

ClrB		movlw		BEXP		;   
		goto		ClrA+1

ClrA		movlw		AEXP		;   
		movwf		FSR
		movlw		4		;  
		movwf		Count1

ClrLoop
		clrf		INDF		;  
		decf		FSR, F		;  
		decfsz		Count1, F
		goto		ClrLoop
		return

;-------------------------------------------------------
;	   EEPROM   A
EEPROM_To_A
		movwf		EE_ADR		;    EEPROM
		movlw		AEXP
		goto		ee_1

;	   EEPROM   B
EEPROM_To_B
		movwf		EE_ADR		;    EEPROM
		movlw		BEXP
ee_1
		movwf		FSR
		movlw		4		; 
		movwf		Count1
EE_read_loop
		call		ReadEEPROM
		banksel		BEXP
		movwf		INDF
		incf		EE_ADR, F
		decf		FSR, F
		decfsz		Count1, F
		goto		EE_read_loop
		return

;	 EEPROM
ReadEEPROM
		movf		EE_ADR,W ;
		banksel		EEADR 		;  2
		movwf		EEADR		;   EEPROM
		banksel		EECON1		; 3
		bcf		EECON1,EEPGD 	;  EEPROM 
		bsf		EECON1,RD    	;  
		banksel		EEDATA		; 2
		movf		EEDATA,W	; W = EEDATA
		return

;-------------------------------------------------------
;	  BARG  EEPROM
;   EEPROM   W
B_To_EEPROM
		movwf		EE_ADR
		movlw		BEXP
		goto		w_ee_1
		
;	  AARG  EEPROM
;   EEPROM   W
A_To_EEPROM
		movwf		EE_ADR
		movlw		AEXP
w_ee_1
		movwf		FSR
		movlw		4		;  
		movwf		Count1
EE_write_loop
		movf		INDF,W
		movwf		EE_DATA
		call		WriteEEPROM
		banksel		BEXP
		incf		EE_ADR, F
		decf		FSR, F
		decfsz		Count1, F
		goto		EE_write_loop

		banksel		EECON1		; 3
		btfsc		EECON1,WR
		goto		$-1		; Wait to complite last write operation
		banksel		BEXP

		return

;	 EEPROM
WriteEEPROM
		banksel		EECON1		;3
		btfsc		EECON1,WR
		goto		$-1
		banksel		EE_ADR
		movf		EE_ADR,W
		banksel		EEADR		;2
		movwf		EEADR
		banksel		EE_DATA
		movf		EE_DATA,W
		banksel		EEDATA		;2
		movwf		EEDATA
		banksel		EECON1		;3
		bcf		EECON1,EEPGD
		bsf		EECON1,WREN
		bcf		INTCON, GIE
		movlw		0x55
		movwf		EECON2
		movlw		0xAA
		movwf		EECON2
		bsf		EECON1,WR
		bsf		INTCON, GIE
		bcf		EECON1,WREN
		return

;-------------------------------------------------------
;	 " "  (4 ) 
; Temp1 =   -    
; Temp2 =   -    

;CEQUA		movlw		CX		; C=A
Copy_From_A
		movwf		Temp1		; Xw=A
		movlw		AEXP
		movwf		Temp2
		goto		Copy

BEQUA		movlw		AEXP		; B=A
Copy_To_B	movwf		Temp2		; B=Xw
		movlw		BEXP
		goto		Copy_B

;AEQUF		movlw		FX		; A=F
Copy_To_A
		movwf		Temp2		; A=Xw
		movlw		AEXP

Copy_B		movwf		Temp1
Copy		movlw		4		;  
		movwf		Count1
Copy_Loop
		movf		Temp2, W
		movwf		FSR
		movf		INDF, W
		movwf		Temp3
		movf		Temp1, W
		movwf		FSR
		movf		Temp3, W
		movwf		INDF
		decf		Temp1, F 	;    
		decf		Temp2, F 	; 
		decfsz		Count1, F
		goto		Copy_Loop
		return

;---------------------------------------------------
;   (4 )     reg. A
Prog_To_A
		movwf		f_tmp		;     
		decf		f_tmp, F	;     
		movlw		AEXP
		movwf		FSR
		goto		prog_1
;   (4 )     reg. B
Prog_To_B
		movwf		f_tmp		;     
		decf		f_tmp, F	;     
		movlw		BEXP
		movwf		FSR
prog_1
		movlw		4		; 
		movwf		Count1
ptb_loop
		pagesel		Table
		movlw 		HIGH Table
		movwf 		PCLATH
		movf		f_tmp, W
		call		Table		; 
		pagesel		$
		movwf		INDF		;  BARG
		incf		f_tmp, F;
		decf		FSR, F
		decfsz		Count1, F
		goto		ptb_loop
		return

;------------------------------------------------------
; W  4     EEPROM
; : Temp1 = W * 8
W_mult_4
		movwf		Temp1
		bcf		STATUS, C
		rlf		Temp1, F	; * 2
		rlf		Temp1, F	; * 4
		return

;X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X=X
;=====================================================================
;     (2...5)
; -
;	NZ -   -  Im,
;		  - Re
;---------------------------------------------------------------------
Calc_NZ
		call		Calc_NZ_1
		movwf		NZ		;  
		call		Calc_NZ_2	; 
		swapf		NZ, F	
		iorwf		NZ, F		;    -   ,
						;  - 
		decfsz		X0, W
		swapf		NZ, F		;   -  Im,  - Re
		return

;---------------------------------------------------------------------
;      (2...5)
; : W (2...5)
;---------------------------------------------------------------------
Calc_NZ_1
		movlw		ADC_U_Re
		movwf		FSR
		bcf		STATUS, C
		rlf		m_count, W	;  * 2
		call		ADC_to_XY	;   XY
		call		MAX_XY
		;     Y2,Y3
		movf		Y0, W
		movwf		Y2
		movf		Y1, W
		movwf		Y3

		movlw		.20-1
		call		ADC_to_XY	;  XY
		call		MAX_XY
		;      X0,X1
		movf		Y2, W
		movwf		X0
		movf		Y3, W
		movwf		X1
		call		MAX_XY	;  X  ,     - 
		
		movf		X1, W
		movwf		AARGB3
		movf		X0, W
		movwf		AARGB2
		clrf		AARGB1
		clrf		AARGB0
		pagesel		BCD
		call		BCD		;   - 
		pagesel		$
		movf		BCD2, F
		btfss		STATUS, Z
		retlw		5
		movlw		0xF0
		andwf		BCD1, W
		btfss		STATUS, Z
		retlw		4
		movf		BCD1, F
		btfss		STATUS, Z
		retlw		3
		retlw		2
;----------------------------------------------------
; Re  Im  X  Y    
;; W - ,    FSR
ADC_to_XY
		addwf		FSR, F	;   Re
		movf		INDF, W
		movwf		X1	;  
		incf		FSR, F
		movf		INDF, W
		movwf		X0	;  
		movlw		.20-1
		addwf		FSR, F	;   Im
		movf		INDF, W
		movwf		Y1	;  
		incf		FSR, F
		movf		INDF, W
		movwf		Y0	;  
		movlw		b'01111111'
		andwf		X0, F
		andwf		Y0, F
		return
;----------------------------------------------------
; 16-   X  Y
;    Y,  -  X
MAX_XY
		; if( y < x )
		movfw	X1		;  
		subwf	Y1,w
		movfw	X0		;  
	 	btfss	STATUS,C 	; c=0 indicates a borrow we need to propagate.
    	incfsz	X0, W 		; handle xh=0xff correctly, unlike ``incf xh,w''.
   		subwf	Y0, W
		btfsc	STATUS, C
		return
		; then:
		; /* y is less than x */
		;   X  Y
		movf		X0, W	; X -> W
		subwf		Y0, W	; (Y-X) -> W
		addwf		X0, F	; X+(Y-X) -> W
		subwf		Y0, F	; Y-(Y-X) -> W

		movf		X1, W	; X -> W
		subwf		Y1, W	; (Y-X) -> W
		addwf		X1, F	; X+(Y-X) -> W
		subwf		Y1, F	; Y-(Y-X) -> W
		return

;=======================================================================
;      DUT
;:
;	X0=0	Re > Im
;	X0=1	Re < Im
;	W =  
;-----------------------------------------------------------------------
Calc_NZ_2
		clrf		X0		;      
		movlw		Z_Re0
		call		Copy_To_A
		movlw		Z_Im0
		call		Copy_To_B
		movlw		0x7F
		andwf		AARGB0, F
		andwf		BARGB0, F	;    
		call		TAGEB32		; A>=B ? 1-, 0-
		iorlw		0
		btfss		STATUS, Z
		goto		div_Re_Im
		incf		X0, F		; ,  Im > Re
		movlw		Z_Im0
		call		Copy_To_A
		movlw		Z_Re0
		call		Copy_To_B
		movlw		0x7F
		andwf		AARGB0, F
		andwf		BARGB0, F	;    

div_Re_Im	;,     Re  Im
		call		FPD32		; A=A/B
		iorlw		0		; 0 - div OK
		btfss		STATUS, Z
		retlw		2
		movlw		LOW	E3
		call		Prog_To_B	; B=1000
		call		TAGEB32		; A>=B ? 1-, 0-
		iorlw		0		; 0 - div OK
		btfss		STATUS, Z
		retlw		2
		call		get_len
		subwf		NZ, W
		sublw		2
		btfsc		STATUS, C
		retlw		2		;     2,  2
		sublw		2
		return

get_len
		call		INT3232		;   
		pagesel		BCD
		call		BCD		;   - 
		pagesel		$
		movf		BCD1, F
		btfss		STATUS, Z
		retlw		2
		movlw		0xF0
		andwf		BCD0, W
		btfss		STATUS, Z
		retlw		1
		retlw		0

;=======================================================
;       DUT
;=======================================================
U_bias
		movlw		1<<U_no_disp2 | 1<<U_no_disp1
		andwf		Flags2, W	;  
		btfsc		STATUS, Z
		goto		U_b1
		movlw		1<<U_no_disp1
		subwf		Flags2, F	;   ,   4 
		return					;U_bias   
U_b1
		bsf			ADCON0,GO	; - 
		btfsc		ADCON0,GO
		goto		$-1		;   

		call		ClrA
		banksel		ADRESL
		movf		ADRESL, W	;  
		banksel		AARGB2
		movwf		AARGB2
		movf		ADRESH, W	;  
		movwf		AARGB1
		call		FLO32
		movlw		LOW K_bias	;- 
		call		EEPROM_To_B
		call		FPM32
		call		BEQUA
		movlw		LOW Coeff_Ubias	;   - ~1000
		call		EEPROM_To_A
		call		FLO32
		call		FPM32	;A=*_0*Coeff_Ubias
		call		INT3232		;   

		pagesel		BCD
		call		BCD
		pagesel		$
		movf		BCD1, F
		btfss		STATUS,Z
		goto		disp_bias
		movlw		3	; Ubias < 0.3V -   
		subwf		BCD0, W
		btfss		STATUS, C
		return
;      12.3V
disp_bias
		pagesel		CmdLCD
		movlw		0x80+.11
		call		CmdLCD
		movlw		3
		movwf		Y2	;  
		bsf		Flags, L_Z 	;    
		swapf		BCD1, F
		movlw		BCD1
		call		DispBCD
		movlw		0x80+.12
		call		CmdLCD
		bcf			Flags, L_Z 	;  
		movlw		BCD0
		call		DispBCD
		call		DispDot
		movlw		BCD0
		call		DispBCD
		movlw		"V"
		call		CharLCD
		pagesel		$
		return


;////////////////////////////////////////////////////////////////////////////////////
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;                   P A G E   N 2
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;////////////////////////////////////////////////////////////////////////////////////
		org		0x1000
;-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x
;    
;-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x
;		include "rotate.inc"

;-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x
;   
;-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x
		include "menu.inc"


;-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x
;       
;-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x
		include "standard.inc"


;-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x
;        
;-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x
		org 	0x1600 ;  256     
Zstd_table
		addwf	PCL,F
		nop
		nop
		nop
Zstd_begin	;       4
		include "Z_std_sm.inc"
;-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x
;         
;-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x
		org 	0x1700 ;  256     
Zsm_table
		addwf	PCL,F
		nop
		nop
		nop
Zsm_begin ;       4
		include "Z_std_sm.inc"

        END
